//
// Class FGGCFG for configurations
//
// Copyright (C) 1998 by Grigori G.Fursin
//

//Import libraries...
import java.io.*;

public class FGGCFG
{
	//Variables
	private String[] CFG;
	private String FNameOfFile;
	private int FNumbOfParams;
	private int FMaxSTRLen;
	private boolean charR=false;

	// *******************************************************************
	public FGGCFG(int NumbOfParams, int MaxSTRLen, String NameOfFile)
	{
		CFG=new String[NumbOfParams];
		FNameOfFile=NameOfFile;
		FNumbOfParams=NumbOfParams;
		FMaxSTRLen=MaxSTRLen;

		for (int i=0; i<NumbOfParams; i++) CFG[i]="";
	}

	// *******************************************************************
	public int Load()
	{
		FileInputStream fin=null;
		int c;
		int cfg_l=0;
		int cfg_b=0;
		String line;

		try
		{
			fin=new FileInputStream(FNameOfFile);
		}
		catch (FileNotFoundException e1)
		{
			return 1;
		}

		try
		{
			while (((c=fin.read())!=-1) && (cfg_l<FNumbOfParams))
			{
				if (c!='\n')
				{
					CFG[cfg_l]+=(char)c;
					cfg_b++;
					if (cfg_b>FMaxSTRLen)
					{
						try
						{
							fin.close();
						}
						catch (Exception e2)
						{}
						return 2;
					}
				}
				else
				{
					cfg_b=0;
					cfg_l++;
				}
			}
		}
		catch (Exception e3)
		{
			try
			{
				fin.close();
			}
			catch (Exception e4)
			{}
			return 4;
		}

		try
		{
			fin.close();
		}
		catch (Exception e5)
		{
			return 5;
		}

		if (cfg_l<FNumbOfParams) return 3;

		for (int i=0; i<FNumbOfParams; i++)
		{
			int jl=CFG[i].length();
			if ((jl!=0) && (CFG[i].charAt(jl-1)=='\r'))
			{
				charR=true;
				line=CFG[i].substring(0,jl-1);
				CFG[i]=line;
			}
		}

		return 0;
	}

	// *******************************************************************
	public int Save()
	{
		FileOutputStream fout=null;

		try
		{
			fout=new FileOutputStream(FNameOfFile);
		}
		catch (IOException e1)
		{
			return 1;
		}

		for (int i=0; i<FNumbOfParams; i++)
		{
			try
			{
				int jl=CFG[i].length();
				for (int j=0; j<jl; j++)
				{
					fout.write(CFG[i].charAt(j));
				}
				if (charR==true) fout.write('\r');
				fout.write('\n');
			}
			catch (Exception e2)
			{
				try
				{
					fout.close();
				}
				catch (Exception e3)
				{}
				return 2;
			}
		}

		try
		{
			fout.close();
		}
		catch (Exception e4)
		{
			return 2;
		}

		return 0;
	}

	// *******************************************************************
	public String Get(int Param) 
	{
		return CFG[Param-1];
	}

	// *******************************************************************
	public void Change(int Param, String str) 
	{
		CFG[Param-1]=str;
	}
}
