//
// Class SCS_C_misc
//
// Copyright (C) 1998 by Grigori G.Fursin
//

//Import libraries...
import java.io.*;
import java.awt.*;

public class SCS_C_misc
{
	// Variables
	public boolean trigger1;

	// *******************************************************************
	public static void ask_key()
	{
		System.out.println("Press <Enter> to quit!");
		try
		{
			System.in.read();
		}
		catch(IOException s)
		{
			System.out.print("Fatal Error: Can't read data from standard input thread\n(");
			System.out.print(s.getMessage());
			System.out.println(")!");
			System.exit(1);
		}
	}

	// *******************************************************************
	public static boolean file_exist(String name)
	{
		FileInputStream fin=null;

		try
		{
			fin=new FileInputStream(name);
		}
		catch (FileNotFoundException e1)
		{
			return false;
		}

		try
		{
			fin.close();
		}
		catch (Exception e2)
		{
			return false;
		}

		return true;
	}

	// *******************************************************************
	public static long file_crc(String name)
	{
		long crc=0;
		int c;
		FileInputStream fin=null;

		try
		{
			fin=new FileInputStream(name);
		}
		catch (FileNotFoundException e1)
		{
			return -1;
		}

		try
		{
			while ((c=fin.read())!=-1) crc+=c;
		}
		catch (Exception e3)
		{
			try
			{
				fin.close();
			}
			catch (Exception e4)
			{}
			return -1;
		}

		try
		{
			fin.close();
		}
		catch (Exception e2)
		{
			return -1;
		}

		return crc;
	}

	// *******************************************************************
	// Param=0 - all configuration
	//       1 - only window options
	//       2 - only client options
	public static void default_cfg(FGGCFG fggcfg, int param) 
	{
		//Window options
		if ((param==0)||(param==1))
		{
			fggcfg.Change(1,"0"); //Position X of Window
			fggcfg.Change(2,"0"); //Position Y of Window
			fggcfg.Change(3,"1"); //Save position on exit?
			fggcfg.Change(4,"1"); //Show Window About?
			fggcfg.Change(5,"0"); //Reserved
			fggcfg.Change(6,"0"); //Reserved
			fggcfg.Change(7,"0"); //Reserved
			fggcfg.Change(8,"0"); //Reserved
			fggcfg.Change(9,"0"); //Reserved
		}
	
		//Server options
		if ((param==0)||(param==2))
		{
			fggcfg.Change(10,"1024");                     //Max Files to be sent
			fggcfg.Change(11,"1024");                     //Max Files to be received
			fggcfg.Change(12,"1024");                     //Max Directories
			fggcfg.Change(13,"login");                    //Login
			fggcfg.Change(14,"password");                 //Password
			fggcfg.Change(15,"scs");                      //FTP Server
			fggcfg.Change(16,"users\\user0001");          //User's directory
			fggcfg.Change(17,"scs/scs/bin/compile.dll");  //'compile' job
			fggcfg.Change(18,"scs/scs/bin/view_cmp.dll"); //view results of 'compile' job
			fggcfg.Change(19,"scs/scs/bin/run.dll");      //'run' job
			fggcfg.Change(20,"scs/scs/bin/view_run.dll"); //view results of 'run' job
		}
	}

	// *******************************************************************
	// Param=0 - all configuration
	//       1 - only window options
	//       2 - only client options
	public static void check_cfg(FGGCFG fggcfg, int param) 
	{
		String str="";

		int cx;
		int cy;

		int dec;
		int x;

		//Window options
		if ((param==0)||(param==1))
		{
			Dimension dim=Toolkit.getDefaultToolkit().getScreenSize();

			int mcx=dim.width;
			int mcy=dim.height;

			try {dec=Integer.decode(fggcfg.Get(1)).intValue();}
			catch (NumberFormatException nfe1) {dec=0;}
			cx=dec;

			try {dec=Integer.decode(fggcfg.Get(2)).intValue();}
			catch (NumberFormatException nfe2) {dec=0;}
			cy=dec;
	
			if (cx<0) cx=0;
			else if (cx > mcx-20) cx=mcx-20;

			if (cy<0) cy=0;
			else if (cy > mcy-20) cy=mcy-20;

			str=String.valueOf(cx);
			fggcfg.Change(1, str);

			str=String.valueOf(cy);
			fggcfg.Change(2, str);
		}
	
		//Server options
		if ((param==0)||(param==2))
		{
			try {dec=Integer.decode(fggcfg.Get(10)).intValue();}
			catch (NumberFormatException nfe1) {dec=0;}
			x=dec;

			if (x<1) x=1;

			str=String.valueOf(x);
			fggcfg.Change(10, str);

			try {dec=Integer.decode(fggcfg.Get(11)).intValue();}
			catch (NumberFormatException nfe1) {dec=0;}
			x=dec;

			if (x<1) x=1;

			str=String.valueOf(x);
			fggcfg.Change(11, str);

			try {dec=Integer.decode(fggcfg.Get(12)).intValue();}
			catch (NumberFormatException nfe1) {dec=0;}
			x=dec;

			if (x<1) x=1;

			str=String.valueOf(x);
			fggcfg.Change(12, str);
		}
	}

	// *******************************************************************
	public static String str_check_del_l(String str, String xcheck)
	{
		String ret=str;

		int l1=str.length();
		int l2=xcheck.length();

		String check=xcheck.toUpperCase();

		if (l1>=l2)
		{
			String x1=str.substring(0,l2).toUpperCase();
			if (x1.equals(check)) ret=str.substring(l2, l1);
		}

		return ret;
	}

	// *******************************************************************
	public static String str_check_del_r(String str, String xcheck)
	{
		String ret=str;

		int l1=str.length();
		int l2=xcheck.length();

		String check=xcheck.toUpperCase();

		if (l1>=l2)
		{
			String x1=str.substring(l1-l2,l1).toUpperCase();
			if (x1.equals(check)) ret=str.substring(0, l1-l2);
		}

		return ret;
	}

	// *******************************************************************
	public static String inet_parse(String str)
	{
		String out="";
		String x="";

		if (str!=null)
		{
			int len=str.length();

			if (len!=0)
			{
				for (int i=0; i<len; i++)
				{
					char c=str.charAt(i);
					int num=c;
					num&=255;

					if (num==32) x="+";
					else if (((num>=33)&&(num<=41)) || 
							((num>=58)&&(num<=63)) || 
							((num>=91)&&(num<=94)) ||
							((num>=123)&&(num<=127)) ||
							(num==43) || (num==44) || (num==47) || (num==96))
					{
						x="%"+Integer.toHexString(num);
					}
					else x=String.valueOf(c);

					out+=x;
				}
			}
		}

		return out;
	}

	// *******************************************************************
	public static void inet_send_post_data (OutputStream os, String str) throws IOException
	{
		if (str!=null)
		{
			int len=str.length();

			if (len!=0)
			{
				for (int i=0; i<len; i++)
				{
					char c=str.charAt(i);
					os.write(c);
				}
			}
		}
	}
}
