// VIEW_CMP.CPP - Implementation file for your Internet Server
//    view_cmp Extension

#include "stdafx.h"
#include <afxdb.h>

#include "view_cmp.h"
#include "misc1.h"

#include <iostream.h>
#include <fstream.h>
#include <string.h>

#include "FGGCfg.h"
CFGGCfg *fggcfg=NULL;
#include "view_cmp_cfg.h"
#define CfgMaxParam 4

#define StrMaxLen 512
#define DirMaxLen 1024

char AppDir[DirMaxLen];

///////////////////////////////////////////////////////////////////////
// The one and only CWinApp object
// NOTE: You may remove this object if you alter your project to no
// longer use MFC in a DLL.

CWinApp theApp;

///////////////////////////////////////////////////////////////////////
// command-parsing map

BEGIN_PARSE_MAP(CView_cmpExtension, CHttpServer)
	// TODO: insert your ON_PARSE_COMMAND() and 
	// ON_PARSE_COMMAND_PARAMS() here to hook up your commands.
	// For example:

	ON_PARSE_COMMAND(Default, CView_cmpExtension, ITS_PSTR ITS_PSTR ITS_PSTR )
	ON_PARSE_COMMAND_PARAMS("Login Password IDCompile")
	DEFAULT_PARSE_COMMAND(Default, CView_cmpExtension)
END_PARSE_MAP(CView_cmpExtension)


///////////////////////////////////////////////////////////////////////
// The one and only CView_cmpExtension object

CView_cmpExtension theExtension;


///////////////////////////////////////////////////////////////////////
// CView_cmpExtension implementation

CView_cmpExtension::CView_cmpExtension()
{
}

CView_cmpExtension::~CView_cmpExtension()
{
}

BOOL CView_cmpExtension::GetExtensionVersion(HSE_VERSION_INFO* pVer)
{
	// Call default implementation for initialization
	CHttpServer::GetExtensionVersion(pVer);

	// Load description string
	TCHAR sz[HSE_MAX_EXT_DLL_NAME_LEN+1];
	ISAPIVERIFY(::LoadString(AfxGetResourceHandle(),
			IDS_SERVER, sz, HSE_MAX_EXT_DLL_NAME_LEN));
	_tcscpy(pVer->lpszExtensionDesc, sz);
	return TRUE;
}

///////////////////////////////////////////////////////////////////////
// CView_cmpExtension command handlers

void CView_cmpExtension::Default(CHttpServerContext* pCtxt,
							 							LPCTSTR pstrLogin, 
														LPCTSTR pstrPassword,
														LPCTSTR pstrIDCompile)
{
	char str1[StrMaxLen];
	char str1a[StrMaxLen];
	char str1b[StrMaxLen];
	
	char str2[DirMaxLen];
	char str2a[DirMaxLen];
	char str2b[DirMaxLen];
	char str2c[DirMaxLen];
	char str2d[DirMaxLen];

	CDatabase db;
	CRecordset fQuery(&db);
	CDBVariant varValue;

	TCHAR szError[1024];

	unsigned long id_user;
	unsigned long id_user_j;
	unsigned long id_compile;

	char directory[DirMaxLen];
	char filename[DirMaxLen];
	char executable_name[DirMaxLen];
	bool mpi_library;
	struct d_t
		{
			unsigned int year;
			unsigned int month;
			unsigned int day;
			unsigned int hour;
			unsigned int minute;
			unsigned int second;
		} d_t_r, d_t_c;
	bool ready;
	bool may_be_killed;
	
	unsigned int il;
	char c;
	
	//Get directory of current application
	GetModuleFileName(AfxGetResourceHandle(),str2,DirMaxLen);
	_splitpath(str2, str2a, str2b, str2c, str2d);
		
	strcpy(AppDir, str2a);
	strcat(AppDir, str2b);
	
	//Get file with HTML header
	strcpy(str2,AppDir);
	strcat(str2,"view_cmp.ht1");

	//Creating header of the HTML document
	if (prt_file_t(pCtxt, str2)!=0)
	{
		*pCtxt << _T("<HTML>\n");
		*pCtxt << _T("<B>Internal Error:</B> Can't find file 'view_cmp.ht1'!<BR>\n");
		*pCtxt << _T("</HTML>\n");
		return;
	}

	//Loading configuration
	strcpy(str2,AppDir);
	strcat(str2,"view_cmp.cfg");

	static CFGGCfg CSCS_CCfg(CfgMaxParam, StrMaxLen, str2);
	fggcfg=&CSCS_CCfg;

	if (CSCS_CCfg.Load()!=0) 
	{
		*pCtxt << _T("<B>Internal Error:</B> Can't find configuration file!<BR>\n");
		*pCtxt << _T("</HTML>\n");
		return;
	}
	//check_cfg(); Checking configuration, if necessary!

	//Ready to process query!
	
	//Checking that Login is not NULL!
	if (strlen(pstrLogin)==0)
	{
		strcpy(str1a, "<CENTER>\n");
		strcat(str1a, "You must present your <B>LOGIN</B>!<BR>\n");
		strcat(str1a, "</CENTER>\n");

		prt_warning(pCtxt, AppDir, "view_cmp", str1a);
		return;
	}
	
	//Checking that Password is not NULL!
	if (strlen(pstrPassword)==0)
	{
		strcpy(str1a, "<CENTER>\n");
		strcat(str1a, "You must present your <B>PASSWORD</B>!<BR>\n");
		strcat(str1a, "</CENTER>\n");

		prt_warning(pCtxt, AppDir, "view_cmp", str1a);
		return;
	}

	//Checking that IDCompile is not NULL!
	if (strlen(pstrIDCompile)==0)
	{
		strcpy(str1a, "<CENTER>\n");
		strcat(str1a, "You must present <B>ID</B> of 'compile' job!<BR>\n");
		strcat(str1a, "</CENTER>\n");

		prt_warning(pCtxt, AppDir, "view_cmp", str1a);
		return;
	}

	id_compile=atol(pstrIDCompile);

	//Connecting to database 'Users' through ODBC
	// (Parameter #1 in configuration = 
	//  Registration name of this database in ODBC)!
	try
	{
		//Open database
		if (!db.Open(_TEXT(fggcfg->Get(1)), FALSE, FALSE, _T("ODBC;"), FALSE))
		{
			*pCtxt << _T("<B>Internal Error:</B> Can't connect to database 'users'!<BR>\n");
			*pCtxt << _T("</HTML>\n");
					
			return;
		}
	
		//Looking for login and password
		strcpy(str1, "SELECT Accounts.ID_USER, Accounts.ACTIVE FROM Accounts WHERE (((Accounts.LOGIN)='");
		strcat(str1, pstrLogin);
		strcat(str1, "') AND ((Accounts.PASSWORD)='");
		strcat(str1, pstrPassword);
		strcat(str1, "'))");

		if (!fQuery.Open(AFX_DB_USE_DEFAULT_TYPE, _TEXT(str1)))
		{
			*pCtxt << _T("<B>Internal Error:</B> Can't open record set of database 'users'!<BR>\n");
			*pCtxt << _T("</HTML>\n");
					
			db.Close();

			return;
		}

		// Create a CDBVariant object to
		// store field data
		if (fQuery.IsEOF())
		{
			strcpy(str1a, "<CENTER>\n");
			strcat(str1a, " <B><TT><FONT SIZE=+2>\n");
			strcat(str1a, "  User was not found!<BR>\n");
			strcat(str1a, " </FONT></TT></B>\n");
			strcat(str1a, " <BR><BR>\n");
			strcat(str1a, " Please, check <B>Login</B> and <B>Password</B>!\n");
			strcat(str1a, "</CENTER>\n");

			prt_warning(pCtxt, AppDir, "view_cmp", str1a);

			fQuery.Close();
			db.Close();

			return;
		}

		//ID_USER
		fQuery.GetFieldValue((short) 0, varValue);
			
		//Must be long
		if (varValue.m_dwType!=DBVT_LONG)
		{
			*pCtxt << _T("<B>Internal Error:</B> Unknown type of 'ID_USER' in database!<BR>\n");
			*pCtxt << _T("</HTML>\n");
					
			fQuery.Close();
			db.Close();

			return;
		}
				
		id_user=varValue.m_lVal;

		//ACTIVE
		varValue.Clear();
		fQuery.GetFieldValue((short) 1, varValue);
			
		//Must be bool				
		if (varValue.m_dwType!=DBVT_BOOL)
		{
			*pCtxt << _T("<B>Internal Error:</B> Unknown type of 'ACTIVE' in database!<BR>\n");
			*pCtxt << _T("</HTML>\n");
					
			fQuery.Close();
			db.Close();

			return;
		}
		
		bool active; 
		if ((varValue.m_boolVal&1)==0) active=false;
		else active=true;

		if (!active)
		{
			strcpy(str1a, "<CENTER>\n");
			strcat(str1a, " <TT><FONT SIZE=+2>\n");
			strcat(str1a, " Your account is <B>NOT ACTIVE</B>!<BR>\n");
			strcat(str1a, " </FONT></TT>\n");
			strcat(str1a, "</CENTER>\n");

			prt_warning(pCtxt, AppDir, "view_cmp", str1a);

			fQuery.Close();
			db.Close();

			return;
		}
		
		fQuery.Close();
		db.Close();
	}
	catch (CDBException *pEx)
	{
		*pCtxt << _T("<B>Internal Error:</B> Error while working with database 'users'!<BR>\n");
		
		if (pEx->GetErrorMessage(szError, sizeof(szError)))
		{
			*pCtxt << _T("(") << szError << _T("!)<BR>\n");
		}

		*pCtxt << _T("</HTML>\n");
		return;
	}

	//Connecting to database 'Jobs' through ODBC
	// (Parameter #2 in configuration = 
	//  Registration name of this database in ODBC)!
	try
	{
		//Open database
		if (!db.Open(_TEXT(fggcfg->Get(2)), FALSE, FALSE, _T("ODBC;"), FALSE))
		{
			*pCtxt << _T("<B>Internal Error:</B> Can't connect to database 'jobs'!<BR>\n");
			*pCtxt << _T("</HTML>\n");
					
			return;
		}

		strcpy(str1, "SELECT Compile.ID_COMPILE, "
							"Compile.ID_USER, "
							"Compile.DIRECTORY, "
							"Compile.FILENAME, "
							"Compile.EXECUTABLE_NAME, "
							"Compile.MPI_LIBRARY, "
							"Compile.DATE_TIME_RECEIVED, "
							"Compile.READY, "
							"Compile.DATE_TIME_COMPLETED, "
							"Compile.MAY_BE_KILLED "
					 "FROM Compile "
					 "WHERE ((Compile.ID_COMPILE)=");
		ultoa(id_compile, str1a, 10);
		strcat(str1, str1a);
		strcat(str1, ")");

		if (!fQuery.Open(AFX_DB_USE_DEFAULT_TYPE, _TEXT(str1)))
		{
			*pCtxt << _T("<B>Internal Error:</B> Can't open record set of database 'jobs'!<BR>\n");
			*pCtxt << _T("</HTML>\n");
					
			db.Close();

			return;
		}

		if (fQuery.IsEOF())
		{
			strcpy(str1a, "<CENTER>\n");
			strcat(str1a, " <B><TT><FONT SIZE=+2>\n");
			strcat(str1a, "  Can't find 'compile' job with ID=");
			ultoa(id_compile, str1b, 10);
			strcat(str1a, str1b);
			strcat(str1a, " !<BR>\n");
			strcat(str1a, " </FONT></TT></B>\n");
			strcat(str1a, "</CENTER>\n");

			prt_warning(pCtxt, AppDir, "view_cmp", str1a);

			fQuery.Close();
			db.Close();

			return;

		}

		//ID_USER of Job
		fQuery.GetFieldValue((short) 1, varValue);
			
		//Must be long
		if (varValue.m_dwType!=DBVT_LONG)
		{
			*pCtxt << _T("<B>Internal Error:</B> Unknown type of 'ID_USER' in database!<BR>\n");
			*pCtxt << _T("</HTML>\n");
					
			fQuery.Close();
			db.Close();

			return;
		}

		id_user_j=varValue.m_lVal;

		if (id_user!=id_user_j)
		{
			strcpy(str1a, "<CENTER>\n");
			strcat(str1a, " <B><TT><FONT SIZE=+2>\n");
			strcat(str1a, "  Can't view 'compile' job of other users!<BR>\n");
			strcat(str1a, " </FONT></TT></B>\n");
			strcat(str1a, "</CENTER>\n");

			prt_warning(pCtxt, AppDir, "view_cmp", str1a);

			fQuery.Close();
			db.Close();

			return;
		}

		//DIRECTORY
		fQuery.GetFieldValue((short) 2, varValue);
	
		if (varValue.m_dwType!=DBVT_STRING)
		{
			*pCtxt << _T("<B>Internal Error:</B> Unknown type of 'DIRECTORY' in database!<BR>\n");
			*pCtxt << _T("</HTML>\n");
					
			fQuery.Close();
			db.Close();

			return;
		}
				
		strcpy(directory,varValue.m_pstring->GetBuffer(StrMaxLen));
		varValue.m_pstring->ReleaseBuffer();
		
		//FILENAME
		fQuery.GetFieldValue((short) 3, varValue);
			
		if (varValue.m_dwType!=DBVT_STRING)
		{
			*pCtxt << _T("<B>Internal Error:</B> Unknown type of 'FILENAME' in database!<BR>\n");
			*pCtxt << _T("</HTML>\n");
					
			fQuery.Close();
			db.Close();

			return;
		}
				
		strcpy(filename,varValue.m_pstring->GetBuffer(StrMaxLen));
		varValue.m_pstring->ReleaseBuffer();
		
		//EXECUTABLE_NAME
		fQuery.GetFieldValue((short) 4, varValue);
			
		if (varValue.m_dwType!=DBVT_STRING)
		{
			*pCtxt << _T("<B>Internal Error:</B> Unknown type of 'EXECUTABLE_NAME' in database!<BR>\n");
			*pCtxt << _T("</HTML>\n");
					
			fQuery.Close();
			db.Close();

			return;
		}
				
		strcpy(executable_name,varValue.m_pstring->GetBuffer(StrMaxLen));
		varValue.m_pstring->ReleaseBuffer();
		
		//MPI_LIBRARY
		fQuery.GetFieldValue((short) 5, varValue);
			
		if (varValue.m_dwType!=DBVT_BOOL)
		{
			*pCtxt << _T("<B>Internal Error:</B> Unknown type of 'MPI_LIBRARY' in database!<BR>\n");
			*pCtxt << _T("</HTML>\n");
					
			fQuery.Close();
			db.Close();

			return;
		}
				
		if ((varValue.m_boolVal&1)==0) mpi_library=false;
		else mpi_library=true;

		//DATE_TIME_RECEIVED
		fQuery.GetFieldValue((short) 6, varValue);
			
		if (varValue.m_dwType==DBVT_NULL)
		{
			d_t_r.year=0;
			d_t_r.month=0;
			d_t_r.day=0;
			d_t_r.hour=0;
			d_t_r.minute=0;
			d_t_r.second=0;
		}
		else
		{
			if (varValue.m_dwType!=DBVT_DATE)
			{
				*pCtxt << _T("<B>Internal Error:</B> Unknown type of 'DATE_TIME_RECEIVED' in database!<BR>\n");
				*pCtxt << _T("</HTML>\n");
			
				fQuery.Close();
				db.Close();

				return;
			}
		
			d_t_r.year=varValue.m_pdate->year;
			d_t_r.month=varValue.m_pdate->month;
			d_t_r.day=varValue.m_pdate->day;
			d_t_r.hour=varValue.m_pdate->hour;
			d_t_r.minute=varValue.m_pdate->minute;
			d_t_r.second=varValue.m_pdate->second;
		}

		//READY
		fQuery.GetFieldValue((short) 7, varValue);
			
		if (varValue.m_dwType!=DBVT_BOOL)
		{
			*pCtxt << _T("<B>Internal Error:</B> Unknown type of 'READY' in database!<BR>\n");
			*pCtxt << _T("</HTML>\n");
					
			fQuery.Close();
			db.Close();

			return;
		}

		if ((varValue.m_boolVal&1)==0) ready=false;
		else ready=true;

		//DATE_TIME_COMPILETED
		fQuery.GetFieldValue((short) 8, varValue);
			
		if (varValue.m_dwType==DBVT_NULL)
		{
			d_t_c.year=0;
			d_t_c.month=0;
			d_t_c.day=0;
			d_t_c.hour=0;
			d_t_c.minute=0;
			d_t_c.second=0;
		}
		else
		{
			if (varValue.m_dwType!=DBVT_DATE)
			{
				*pCtxt << _T("<B>Internal Error:</B> Unknown type of 'DATE_TIME_COMPLETED' in database!<BR>\n");
				*pCtxt << _T("</HTML>\n");
					
				fQuery.Close();
				db.Close();

				return;
			}

			d_t_c.year=varValue.m_pdate->year;
			d_t_c.month=varValue.m_pdate->month;
			d_t_c.day=varValue.m_pdate->day;
			d_t_c.hour=varValue.m_pdate->hour;
			d_t_c.minute=varValue.m_pdate->minute;
			d_t_c.second=varValue.m_pdate->second;
		}

		//MAY_BE_KILLED
		fQuery.GetFieldValue((short) 9, varValue);
			
		if (varValue.m_dwType!=DBVT_BOOL)
		{
			*pCtxt << _T("<B>Internal Error:</B> Unknown type of 'MAY_BE_KILLED' in database!<BR>\n");
			*pCtxt << _T("</HTML>\n");
					
			fQuery.Close();
			db.Close();

			return;
		}

		if ((varValue.m_boolVal&1)==0) may_be_killed=false;
		else may_be_killed=true;
	}
	catch (CDBException *pEx)
	{
		*pCtxt << _T("<B>Internal Error:</B> Error while working with database 'jobs'!<BR>\n");
		
		if (pEx->GetErrorMessage(szError, sizeof(szError)))
		{
			*pCtxt << _T("(") << szError << _T("!)<BR>\n");
		}

		*pCtxt << _T("</HTML>\n");
		return;
	}

	//Print info about job
	strcpy(str2,AppDir);
	strcat(str2,"view_cmp.ht2");
		
	if (prt_file_t(pCtxt, str2)!=0)
	{
		*pCtxt << _T("<HTML>\n");
		*pCtxt << _T("<B>Internal Error:</B> Can't find file 'view_cmp.ht2'!<BR>\n");
		*pCtxt << _T("</HTML>\n");
		return;
	}

	//Print info about job
	strcpy(str2,AppDir);
	strcat(str2,"view_cmp.ht4");
		
	if (prt_file_t(pCtxt, str2)!=0)
	{
		*pCtxt << _T("<HTML>\n");
		*pCtxt << _T("<B>Internal Error:</B> Can't find file 'view_cmp.ht4'!<BR>\n");
		*pCtxt << _T("</HTML>\n");
		return;
	}

	*pCtxt << _T(" <TR>\n");
	
	*pCtxt << _T("  <TD ALIGN=\"RIGHT\" VALIGN=\"TOP\">\n");
		ultoa(id_compile, str1, 10);
		*pCtxt << _TEXT(str1);
	*pCtxt << _T("  </TD>\n");

	*pCtxt << _T("  <TD ALIGN=\"RIGHT\" VALIGN=\"TOP\">\n");
		ultoa(id_user, str1, 10);
		*pCtxt << _TEXT(str1);
	*pCtxt << _T("  </TD>\n");

	*pCtxt << _T("  <TD ALIGN=\"LEFT\" VALIGN=\"TOP\">\n");
		*pCtxt << _TEXT(directory);
	*pCtxt << _T("  </TD>\n");

	*pCtxt << _T("  <TD ALIGN=\"LEFT\" VALIGN=\"TOP\">\n");
		*pCtxt << _TEXT(filename);
	*pCtxt << _T("  </TD>\n");
	
	*pCtxt << _T("  <TD ALIGN=\"CENTER\" VALIGN=\"TOP\">\n");
		*pCtxt << _TEXT(executable_name);
	*pCtxt << _T("  </TD>\n");
	
	*pCtxt << _T("  <TD ALIGN=\"CENTER\" VALIGN=\"TOP\">\n");
		if (mpi_library) *pCtxt << _T("Yes");
		else *pCtxt << _T("No");
	*pCtxt << _T("  </TD>\n");
	
	*pCtxt << _T("  <TD ALIGN=\"CENTER\" VALIGN=\"TOP\">\n");
		itoa(d_t_r.year, str1, 10);
		*pCtxt << _TEXT(str1) << _T("/");
		itoa(d_t_r.month, str1, 10);
		*pCtxt << _TEXT(str1) << _T("/");
		itoa(d_t_r.day, str1, 10);
		*pCtxt << _TEXT(str1) << _T(" ");
		itoa(d_t_r.hour, str1, 10);
		*pCtxt << _TEXT(str1) << _T(":");
		itoa(d_t_r.minute, str1, 10);
		*pCtxt << _TEXT(str1) << _T(":");
		itoa(d_t_r.second, str1, 10);
		*pCtxt << _TEXT(str1) << _T("\n");
	*pCtxt << _T("  </TD>\n");
	
	*pCtxt << _T("  <TD ALIGN=\"CENTER\" VALIGN=\"TOP\">\n");
	*pCtxt << _T("   <B>\n");
		if (ready) *pCtxt << _T("Yes");
		else *pCtxt << _T("No");
	*pCtxt << _T("   </B>\n");
	*pCtxt << _T("  </TD>\n");
	
	*pCtxt << _T("  <TD ALIGN=\"CENTER\" VALIGN=\"TOP\">\n");
		if (ready)
		{
			itoa(d_t_c.year, str1, 10);
			*pCtxt << _TEXT(str1) << _T("/");
			itoa(d_t_c.month, str1, 10);
			*pCtxt << _TEXT(str1) << _T("/");
			itoa(d_t_c.day, str1, 10);
			*pCtxt << _TEXT(str1) << _T(" ");
			itoa(d_t_c.hour, str1, 10);
			*pCtxt << _TEXT(str1) << _T(":");
			itoa(d_t_c.minute, str1, 10);
			*pCtxt << _TEXT(str1) << _T(":");
			itoa(d_t_c.second, str1, 10);
			*pCtxt << _TEXT(str1) << _T("\n");
		}
	*pCtxt << _T("  </TD>\n");
	
	*pCtxt << _T("  <TD ALIGN=\"CENTER\" VALIGN=\"TOP\">\n");
	*pCtxt << _T("   <B>\n");
		if (may_be_killed) *pCtxt << _T("Yes");
		else *pCtxt << _T("No");
	*pCtxt << _T("   </B>\n");
	*pCtxt << _T("  </TD>\n");
	
	*pCtxt << _T(" </TR>\n");
	*pCtxt << _T("</TABLE>\n");
	
	//Write Status of job (Ready or not) in COMMENTS for SCS Client !!!
	*pCtxt << _T("<!--\n");
	*pCtxt << _T("SCS_C_READY_COMPILE=");
		if (ready) *pCtxt << _T("1");
		else *pCtxt << _T("0");
	*pCtxt << _T("\n-->\n");
	
	//Result:
	if (ready)
	{
		//View output (cmp) file
		strcpy(str2,AppDir);
		strcat(str2,"view_cmp.ht5");
		
		if (prt_file_t(pCtxt, str2)!=0)
		{
			*pCtxt << _T("<HTML>\n");
			*pCtxt << _T("<B>Internal Error:</B> Can't find file 'view_cmp.ht5'!<BR>\n");
			*pCtxt << _T("</HTML>\n");
			return;
		}
		
		strcpy(str1, fggcfg->Get(3));
		il=strlen(str1);
		if (il!=0)
		{
			if (str1[il-1]!='\\') strcat(str1, "\\");
		}

		ultoa(id_compile, str1a, 10);
		strcat(str1, str1a);
		strcat(str1, fggcfg->Get(4));

		ifstream fin(str1, ios::nocreate);
		if (fin)
		{
			str1a[1]='\0';
			while (fin.get(c))
			{
				if (c=='\n') *pCtxt << _T("<BR>\n");
				else
				{
					str1a[0]=c;
					*pCtxt << _TEXT(str1a);
				}
			}
			fin.close();
		}
		
		*pCtxt << _T("<BR>\n");	
	}
	
	strcpy(str2,AppDir);
	strcat(str2,"view_cmp.ht3");
		
	if (prt_file_t(pCtxt, str2)!=0)
	{
		*pCtxt << _T("<HTML>\n");
		*pCtxt << _T("<B>Internal Error:</B> Can't find file 'view_cmp.ht3'!<BR>\n");
		*pCtxt << _T("</HTML>\n");
		return;
	}
	
	*pCtxt << "</BODY>\n";
	*pCtxt << "</HTML>\n";
	
	//fggcfg->Save(); //Saving configuration, if necessary!
}

// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CView_cmpExtension, CHttpServer)
	//{{AFX_MSG_MAP(CView_cmpExtension)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0



///////////////////////////////////////////////////////////////////////
// If your extension will not use MFC, you'll need this code to make
// sure the extension objects can find the resource handle for the
// module.  If you convert your extension to not be dependent on MFC,
// remove the comments arounn the following AfxGetResourceHandle()
// and DllMain() functions, as well as the g_hInstance global.

/****

static HINSTANCE g_hInstance;

HINSTANCE AFXISAPI AfxGetResourceHandle()
{
	return g_hInstance;
}

BOOL WINAPI DllMain(HINSTANCE hInst, ULONG ulReason,
					LPVOID lpReserved)
{
	if (ulReason == DLL_PROCESS_ATTACH)
	{
		g_hInstance = hInst;
	}

	return TRUE;
}

****/
