// Job.cpp : implementation file
//

#include "stdafx.h"
#include "scs_s_c.h"
#include "Job.h"
#include "process.h" //for spawnl

#include <afxdb.h>
#include <fstream.h>

#include "misc.h"

#include "fggcfg.h"
extern CFGGCfg* fggcfg;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CJob dialog


CJob::CJob(CWnd* pParent /*=NULL*/)
	: CDialog(CJob::IDD, pParent)
{
	//{{AFX_DATA_INIT(CJob)
	//}}AFX_DATA_INIT
}


void CJob::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJob)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CJob, CDialog)
	//{{AFX_MSG_MAP(CJob)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJob message handlers

BOOL CJob::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	status_of_timer=false;
	cancel=false;
	
	m_timer = NULL;
	m_timer = SetTimer(1, 500, NULL);

	if (m_timer==NULL)
	{
		MessageBox(_T("Not enough timers available for this window!"),
				_T("Warning"), MB_ICONEXCLAMATION | MB_OK);

		// signal creation failure...
		OnCancel();
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CJob::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CString str;
	char str1[StrMaxLen];
	char str1a[StrMaxLen];
	char str2[StrMaxLen];
	
	CDatabase db;
	CRecordset fQuery(&db);
	CDBVariant varValue;

	TCHAR szError[StrMaxLen];

	unsigned long id_compile;
	unsigned long id_user;
	char directory[DirMaxLen];
	char filename[DirMaxLen];
	char executable_name[DirMaxLen];
	bool mpi_library;
	char ftp_root_directory[DirMaxLen];

	char CurDir[DirMaxLen];
	char file_w_results[DirMaxLen];
	char file_job[DirMaxLen];
	char filename_job[]="compile.job";
	char user_dir[DirMaxLen];

	bool status;

	bool dummy;

//	int ret;

	BOOL bOk=0;

	PROCESS_INFORMATION pi;						
	STARTUPINFO si = {0};
	si.cb = sizeof(si);
	
	HANDLE m_hFile=NULL;

	SECURITY_ATTRIBUTES g_sa = {sizeof(SECURITY_ATTRIBUTES),NULL,TRUE};;

	DWORD dwCreateFlags=0;

	bool wait_failed=false;

	//Timer
	if (!status_of_timer)
	{
		status_of_timer=true;

		GetDlgItem(IDC_STATIC_S)->SetWindowText("Connecting to database ...");
		UpdateData(false);
		
		status=false;
		
		//Connecting to database 'Jobs' through ODBC
		try
		{
			//Open database
			if (!db.Open(_TEXT(fggcfg->Get(11)), FALSE, FALSE, _T("ODBC;"), FALSE))
			{
				AfxMessageBox("Fatal Internal Error: Can't connect to database [E100]!");
				cancel=true;
				goto _end_a;
			}

			strcpy(str1, "SELECT Compile.ID_COMPILE, Compile.ID_USER, "
			                    "Compile.DIRECTORY, Compile.FILENAME, "
								"Compile.EXECUTABLE_NAME, "
								"Compile.MPI_LIBRARY, "
								"Accounts.FTP_ROOT_DIR "
			             "FROM Accounts INNER JOIN Compile ON Accounts.ID_USER=Compile.ID_USER "
			             "WHERE (((Compile.READY)=No) AND ((Compile.MAY_BE_KILLED)=No) AND ((Accounts.ACTIVE)=Yes)) "
						 "ORDER BY Accounts.PRIORITY, Compile.DATE_TIME_RECEIVED");

			if (!fQuery.Open(AFX_DB_USE_DEFAULT_TYPE, _TEXT(str1)))
			{
				AfxMessageBox("Fatal Internal Error: Can't open Query to database [E110]!");
				cancel=true;
				goto _end;
			}
			else if (!fQuery.IsEOF())
			{
				//ID_COMPILE
				fQuery.GetFieldValue((short) 0, varValue);
			
				if (varValue.m_dwType!=DBVT_LONG)
				{
					AfxMessageBox("Fatal Internal Error: Unknown type of 'ID_COMPILE' in database [E120]!");
					cancel=true;
					goto _end;
				}
				
				id_compile=varValue.m_lVal;
		
				str.Format("%u",id_compile);
				GetDlgItem(IDC_STATIC1)->SetWindowText(str);
				UpdateData(false);
				
				//ID_USER
				fQuery.GetFieldValue((short) 1, varValue);
			
				if (varValue.m_dwType!=DBVT_LONG)
				{
					AfxMessageBox("Fatal Internal Error: Unknown type of 'ID_USER' in database [E130]!");
					cancel=true;
					goto _end;
				}
				
				id_user=varValue.m_lVal;
		
				str.Format("%u",id_user);
				GetDlgItem(IDC_STATIC2)->SetWindowText(str);
				UpdateData(false);

				//DIRECTORY
				fQuery.GetFieldValue((short) 2, varValue);
			
				if (varValue.m_dwType!=DBVT_STRING)
				{
					AfxMessageBox("Fatal Internal Error: Unknown type of 'DIRECTORY' in database [E140]!");
					cancel=true;
					goto _end;
				}
				
				strcpy(directory,varValue.m_pstring->GetBuffer(StrMaxLen));
				varValue.m_pstring->ReleaseBuffer();
		
				GetDlgItem(IDC_STATIC3)->SetWindowText(directory);
				UpdateData(false);

				//FILENAME
				fQuery.GetFieldValue((short) 3, varValue);
			
				if (varValue.m_dwType!=DBVT_STRING)
				{
					AfxMessageBox("Fatal Internal Error: Unknown type of 'FILENAME' in database [E150]!");
					cancel=true;
					goto _end;
				}
				
				strcpy(filename,varValue.m_pstring->GetBuffer(StrMaxLen));
				varValue.m_pstring->ReleaseBuffer();
		
				GetDlgItem(IDC_STATIC4)->SetWindowText(filename);
				UpdateData(false);

				//EXECUTABLE_NAME
				fQuery.GetFieldValue((short) 4, varValue);
			
				if (varValue.m_dwType!=DBVT_STRING)
				{
					AfxMessageBox("Fatal Internal Error: Unknown type of 'EXECUTABLE_NAME' in database [E160]!");
					cancel=true;
					goto _end;
				}
				
				strcpy(executable_name,varValue.m_pstring->GetBuffer(StrMaxLen));
				varValue.m_pstring->ReleaseBuffer();
		
				GetDlgItem(IDC_STATIC5)->SetWindowText(executable_name);
				UpdateData(false);

				//MPI_LIBRARY
				fQuery.GetFieldValue((short) 5, varValue);
			
				if (varValue.m_dwType!=DBVT_BOOL)
				{
					AfxMessageBox("Fatal Internal Error: Unknown type of 'MPI_LIBRARY' in database [E170]!");
					cancel=true;
					goto _end;
				}
				
				if ((varValue.m_boolVal&1)==0) mpi_library=false;
				else mpi_library=true;

				if (mpi_library) str="Yes";
				else str="No";

				GetDlgItem(IDC_STATIC6)->SetWindowText(str);
				UpdateData(false);

				//FTP_ROOT_DIRECTORY
				fQuery.GetFieldValue((short) 6, varValue);
			
				if (varValue.m_dwType!=DBVT_STRING)
				{
					AfxMessageBox("Fatal Internal Error: Unknown type of 'FTP_ROOT_DIRECTORY' in database [E180]!");
					cancel=true;
					goto _end;
				}
				
				strcpy(ftp_root_directory,varValue.m_pstring->GetBuffer(StrMaxLen));
				varValue.m_pstring->ReleaseBuffer();
				
				status=true;
_end:				
				fQuery.Close();
			}
			
			db.Close();

_end_a:
			//end if error during connecting to database!
			dummy=true;
		}
		catch (CDBException *pEx)
		{
			str="Fatal Internal Error (while working with database) [E190]:\n";
			if (pEx->GetErrorMessage(szError, sizeof(szError)))
			{
				str+=szError;
			}
			AfxMessageBox(str);
			cancel=true;
		}
		
		if ((status)&&(!cancel))
		{
			//Preparing to compile...
			GetDlgItem(IDC_STATIC_S)->SetWindowText("Compiling ...");
			UpdateData(false);

			//Get current directory
			GetCurrentDirectory(DirMaxLen, CurDir);

			//Set file with results
			add_dir(str1, fggcfg->Get(15), true);
			ultoa(id_compile, str1a, 10);
			strcat(str1, str1a);
			strcat(str1, fggcfg->Get(19));
			strcpy(file_w_results, str1);
				
			//Set file with job for compiler
			add_dir(str1, fggcfg->Get(20), true);
			strcat(str1, filename_job);
			strcpy(file_job, str1);
		
			//Set current user's directory
			add_dir(str1, fggcfg->Get(14), true); 
			add_dir(str1, ftp_root_directory, false);
			add_dir(str1, directory, false);
			strcpy(user_dir, str1);
				
			//Creating file with job for compiler
			ofstream fout1(file_job);
			
			if (!fout1)
			{
				AfxMessageBox("Fatal Internal Error: Can't open file with job for compiler [E200]");
				cancel=true;
				goto _end1;
			}

			fout1 << filename << '\n';

			fout1 << "/O2\n"; //To remove handling of errors?! Optimizing for speed!
			fout1 << "/I" << fggcfg->Get(12) << '\n';
			if (mpi_library) fout1 << "/I" << fggcfg->Get(17) << '\n';
			fout1 << "/link /LIBPATH:" << fggcfg->Get(13) << '\n';
			if (mpi_library)
			{
				fout1 << "/link /LIBPATH:" << fggcfg->Get(18) << '\n';
				fout1 << "/link " << fggcfg->Get(21) << '\n';
			}
			fout1 << "/link /OUT:" << executable_name << '\n';
			fout1 << "/link /NOLOGO" << '\n';
				
			fout1.close();
			
			//Set current user directory
			if (SetCurrentDirectory(user_dir)==0)
			{
				save_str(file_w_results, "SCS Error: Can't find user's project directory [E210]!\n");
				goto _end2;
			}
			
			//Compiling
			strcpy(str1, fggcfg->Get(16));
			strcat(str1, " @");
			strcat(str1, file_job);
			strcat(str1, " /nologo");
									
			//Set output file
			m_hFile = CreateFile(file_w_results,
									GENERIC_WRITE,
									FILE_SHARE_WRITE, 
									&g_sa,
									CREATE_ALWAYS, 
									FILE_ATTRIBUTE_NORMAL, 
									NULL);
									
			si.dwFlags |= STARTF_USESTDHANDLES;
			si.hStdInput=NULL;
			si.hStdOutput=m_hFile;
			si.hStdError=m_hFile;

			//Starting job!
			strcpy(str2, "SCS_S_C ID=");
			ultoa(id_compile, str1a, 10);
			strcat(str2, str1a);
			si.lpTitle=str2;
			si.dwFlags |= STARTF_USESHOWWINDOW;
			si.wShowWindow=SW_MINIMIZE;

			dwCreateFlags = CREATE_DEFAULT_ERROR_MODE | 
							CREATE_NEW_CONSOLE |
							CREATE_NEW_PROCESS_GROUP;
									
			bOk = CreateProcess(NULL, str1,
									 NULL, NULL, TRUE,
									 dwCreateFlags, NULL, 
									 user_dir, &si, &pi );

			if (m_hFile!=NULL) CloseHandle(m_hFile);
									
			if (!bOk)
			{
				AfxMessageBox("Fatal Internal Error: Can't run compiler [E220]!");
				cancel=true;
				remove(file_job);
				goto _end1;
			}

			wait_failed=false;
			if (WaitForSingleObject(pi.hProcess, INFINITE)==WAIT_FAILED) wait_failed=true;
			
			remove(file_job);

			CloseHandle(pi.hThread);
			CloseHandle(pi.hProcess);
			
			if (wait_failed) 
			{
				AfxMessageBox("Fatal Internal Error found while waiting for completing of 'compile' job [E230]!");
				cancel=true;
				goto _end1;
			}

			/*
			strcat(str1, " >");
			strcat(str1, file_w_results);

			ret=system(str1);

			remove(file_job);

			if (ret==-1)
			{
				AfxMessageBox("Fatal Internal Error: Can't run compiler!");
				cancel=true;
				goto _end1;
			}
			*/

_end2:
			//Restore current directory
			if (SetCurrentDirectory(CurDir)==0)
			{
				AfxMessageBox("Fatal Internal Error: Can't restore current directory [E240]!");
				cancel=true;
				goto _end1;
			}

			//Update status 'READY'
			try
			{
			//Open database
				if (!db.Open(_TEXT(fggcfg->Get(11)), FALSE, FALSE, _T("ODBC;"), FALSE))
				{
					AfxMessageBox("Fatal Internal Error: Can't connect to database [E250]!");
					cancel=true;
					goto _end_b;
				}

				GetDlgItem(IDC_STATIC_S)->SetWindowText("Updating 'READY' ...");
				UpdateData(false);
				
				strcpy(str1,"UPDATE Compile "
					        "SET Compile.READY=Yes, "
						        "Compile.DATE_TIME_COMPLETED='");

				_strdate(str1a);
				strcat(str1, str1a);
				strcat(str1," ");
	
				_strtime(str1a);
				strcat(str1, str1a);
				strcat(str1, "' "
				             "WHERE Compile.ID_COMPILE=");

				ultoa(id_compile, str1a, 10);
				strcat(str1, str1a);

				db.ExecuteSQL(_TEXT(str1));
				db.Close();

_end_b:
				//end if error during connecting to database!
				dummy=true;
			}
			catch (CDBException *pEx)
			{
				str="Fatal Internal Error (while working with database) [E260]:\n";
				if (pEx->GetErrorMessage(szError, sizeof(szError)))
				{
					str+=szError;
				}
				AfxMessageBox(str);
				cancel=true;
			}
		}

_end1:
		KillTimer(m_timer);
		m_timer = NULL;
		
		if (cancel) OnCancel();
		else OnOK();
	}
	else UpdateData(false);
	
	CDialog::OnTimer(nIDEvent);
}
