// SCS_S_C.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "SCS_S_C.h"
#include "WndDlg.h"

#include "About.h"
#include "misc.h"

//For configuration
#include "fggcfg.h" 
CFGGCfg* fggcfg=NULL;
#define CfgMaxParam 22

char AppDir[DirMaxLen];

bool IAboutBox;

CWndDlg* pMainDlg=NULL;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CApp

BEGIN_MESSAGE_MAP(CApp, CWinApp)
	//{{AFX_MSG_MAP(CApp)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CApp construction

CApp::CApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CApp object

CApp *pApp;
CApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CApp initialization

BOOL CApp::InitInstance()
{
	char str1[DirMaxLen];
	char str1a[DirMaxLen];
	char str1b[DirMaxLen];
	char str1c[DirMaxLen];
	char str1d[DirMaxLen];

	pApp=&theApp;
	
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	//Get Directory of exe file
	GetModuleFileName(AfxGetResourceHandle(), str1, DirMaxLen);
	_splitpath(str1, str1a, str1b, str1c, str1d);
	
	strcpy(AppDir, str1a);
	strcat(AppDir, str1b);

	//Preparing configuration
	strcpy(str1,AppDir);
	strcat(str1,"scs_s_c.cfg");
	
	static CFGGCfg CSCS_S_CCfg(CfgMaxParam, StrMaxLen, str1);
	
	fggcfg=&CSCS_S_CCfg;
	if (CSCS_S_CCfg.Load()!=0) default_cfg(0);
	check_cfg(0);

	if (strcmp(fggcfg->Get(4),"1")==0)
	{
		IAboutBox=true;
		CAbout about;
		about.DoModal();
		IAboutBox=false;
	}

	// Create main window
	TRY
	{           
		CWndDlg* pMainWnd = new CWndDlg;
		pMainDlg=pMainWnd;
		m_pMainWnd = pMainWnd;
		return pMainWnd->Create();
	}
	CATCH_ALL(e)
	{
		TRACE0("Failed to create main dialog\n");
		return FALSE;
	}
	END_CATCH_ALL
}

// Param=0 - all configuration
//       1 - only window options
//       2 - only server options
void CApp::default_cfg(unsigned int param) 
{
	//Window options
	if ((param==0)||(param==1))
	{
		fggcfg->Change(1,"0"); //Position X of Window
		fggcfg->Change(2,"0"); //Position Y of Window
		fggcfg->Change(3,"1"); //Save position on exit?
		fggcfg->Change(4,"1"); //Show Window About?
		fggcfg->Change(5,"0"); //Reserved
		fggcfg->Change(6,"0"); //Reserved
		fggcfg->Change(7,"0"); //Reserved
		fggcfg->Change(8,"0"); //Reserved
		fggcfg->Change(9,"0"); //Reserved
	}
	
	//Server options
	if ((param==0)||(param==2))
	{
		fggcfg->Change(10,"12"); //Period
		fggcfg->Change(11,"scs_jobs"); //ODBC name of database with 'compile' jobs
		fggcfg->Change(12,"m:\\devstudio\\vc\\include");
		fggcfg->Change(13,"m:\\devstudio\\vc\\lib");
		fggcfg->Change(14,"l:\\InetPub\\FTPROOT\\Users");
		fggcfg->Change(15,"k:\\!fggprj\\diplom\\soft\\nt\\results");
		fggcfg->Change(16,"k:\\!fggprj\\diplom\\soft\\nt\\mvcc\\cl.exe");
		fggcfg->Change(17,"k:\\!fggprj\\diplom\\soft\\nt\\winmpich\\include");
		fggcfg->Change(18,"k:\\!fggprj\\diplom\\soft\\nt\\winmpich\\lib");
		fggcfg->Change(19,".cmp");
		fggcfg->Change(20,"i:\\temp");
		fggcfg->Change(21,"winmpich.lib");
		fggcfg->Change(22,"0");  //AutoRun
	}
}

// Param=0 - all configuration
//       1 - only window options
//       2 - only server options
void CApp::check_cfg(unsigned int param)
{
	char str[StrMaxLen];
	
	//Window options
	if ((param==0)||(param==1))
	{
		int mcx=GetSystemMetrics(SM_CXFULLSCREEN);
		int mcy=GetSystemMetrics(SM_CYFULLSCREEN);
	
		int cx=atoi(fggcfg->Get(1));
		int cy=atoi(fggcfg->Get(2));
		
		if (cx<0) cx=0;
		else if (cx > mcx-20) cx=mcx-20;

		if (cy<0) cy=0;
		else if (cy > mcy-20) cy=mcy-20;

		ultoa(cx, str, 10);
		fggcfg->Change(1, str);

		ultoa(cy, str, 10);
		fggcfg->Change(2, str);
	}
	
	//Server options
	if ((param==0)||(param==2))
	{
		//Period
		int x=atoi(fggcfg->Get(10));
		if (x<1) 
		{
			x=1;
			ultoa(x, str, 10);
			fggcfg->Change(10, str);
		}

		del_s(fggcfg, 12, StrMaxLen);
		del_s(fggcfg, 13, StrMaxLen);
		del_s(fggcfg, 14, StrMaxLen);
		del_s(fggcfg, 15, StrMaxLen);
		del_s(fggcfg, 16, StrMaxLen);
		del_s(fggcfg, 17, StrMaxLen);
		del_s(fggcfg, 18, StrMaxLen);
		del_s(fggcfg, 20, StrMaxLen);
	}
}
