// WndDlg.cpp : Implementation file
//

// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1997 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.

/*****************************************************************************
  Development Team:
    Mary Kirtland
  Ported to 32-bit by:
    Mike Hedley	
  Created by Microsoft Product Support Services, Premier ISV Support
  Copyright (c) 1997 Microsoft Corporation. All rights reserved.
\****************************************************************************/

#include "stdafx.h"
#include <afxpriv.h>
#include "resource.h"
#include "wnddlg.h"  

#include <io.h>
#include <fstream.h>

#include <afxdb.h>

#include "About.h"
#include "OptWnd.h"
#include "OptServ.h"
#include "KillJob.h"

#include "misc.h"

#include "fggcfg.h"
extern CFGGCfg* fggcfg;

#define xmax 20 //For drawing system load
#define xstep 2
#define max_proc_if_error 8

#define ID_TIMER	0
#define ID_TIMER1	1

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
                 
/////////////////////////////////////////////////////////////////////////////
// CWndDlg control bar data 

static UINT auIDStatusBar[] = { 
NULL
	//   ID_SEPARATOR
};         

static UINT auIDToolBar[] = { 
	ID_EXIT,
	ID_SEPARATOR,
	ID_START_SERVER,
	ID_STOP_SERVER,
	ID_SEPARATOR,
	ID_KILL_JOB,
	ID_SEPARATOR,
	ID_ABOUT
};

/////////////////////////////////////////////////////////////////////////////
// CWndDlg dialog

CWndDlg::CWndDlg()
{
	//{{AFX_DATA_INIT(CWndDlg)
	//}}AFX_DATA_INIT
}

BOOL CWndDlg::Create()
{
	return CModelessMain::Create(CWndDlg::IDD,
								 auIDStatusBar, 
								 sizeof(auIDStatusBar)/sizeof(UINT),
								 auIDToolBar,
								 sizeof(auIDToolBar)/sizeof(UINT),
								 IDR_MAIN);	
}								 

void CWndDlg::DoDataExchange(CDataExchange* pDX)
{
	CModelessMain::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWndDlg)
	DDX_Control(pDX, IDC_STATIC8, m_st5);
	DDX_Control(pDX, IDC_STATIC7, m_st4);
	DDX_Control(pDX, IDC_STATIC3, m_st3);
	DDX_Control(pDX, IDC_STATIC2, m_st2);
	DDX_Control(pDX, IDC_STATIC1, m_st1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWndDlg, CModelessMain)
	//{{AFX_MSG_MAP(CWndDlg)
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_COMMAND(ID_START_SERVER, OnStartServer)
	ON_COMMAND(ID_STOP_SERVER, OnStopServer)
	ON_UPDATE_COMMAND_UI(ID_START_SERVER, OnUpdateStartServer)
	ON_UPDATE_COMMAND_UI(ID_STOP_SERVER, OnUpdateStopServer)
	ON_COMMAND(ID_ABOUT, OnAbout)
	ON_COMMAND(ID_EXIT, OnExit)
	ON_COMMAND(ID_OPTIONS_SERVER, OnOptionsServer)
	ON_COMMAND(ID_OPTIONS_WINDOW, OnOptionsWindow)
	ON_UPDATE_COMMAND_UI(ID_ABOUT, OnUpdateAbout)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_SERVER, OnUpdateOptionsServer)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_WINDOW, OnUpdateOptionsWindow)
	ON_COMMAND(ID_KILL_JOB, OnKillJob)
	ON_UPDATE_COMMAND_UI(ID_KILL_JOB, OnUpdateKillJob)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CWndDlg::OnInitDialog

BOOL CWndDlg::OnInitDialog()
{
	CModelessMain::OnInitDialog();   
	
	// Initialize windows contents
	CMenu *pMenu=GetSystemMenu(FALSE);
	if (pMenu!=NULL)
	{
		pMenu->DeleteMenu(SC_MAXIMIZE, MF_BYCOMMAND);
		pMenu->DeleteMenu(SC_SIZE, MF_BYCOMMAND);
	}
	
	COLORREF clr;	

	pDC=new CClientDC(this);

	//For green and red circles
	clr=RGB(255,0,0);
	pMyPen1=new CPen(PS_SOLID,1,clr);
	pMyBrush1=new CBrush(clr);

	clr=RGB(0,255,0);
	pMyPen2=new CPen(PS_SOLID,1,clr);
	pMyBrush2=new CBrush(clr);

	pMyPen3=new CPen(PS_NULL, 1, RGB(255,255,255));

	GetDlgItem(IDC_STATIC21)->GetWindowRect(&rect1);
	GetDlgItem(IDC_STATIC22)->GetWindowRect(&rect2);
	ScreenToClient(&rect1);
	ScreenToClient(&rect2);

	ix1=rect1.right-rect1.left;
	iy1=rect1.bottom-rect1.top;
	ix2=rect2.right-rect2.left;
	iy2=rect2.bottom-rect2.top;

	ir1=min(ix1,iy1);
	ir2=min(ix2,iy2);

	//For load ...
	clr=RGB(0,0,0);
	pMyPen5=new CPen(PS_SOLID,1,clr);
	pMyBrush5=new CBrush(clr);

	clr=RGB(0,100,0);
	pMyPen6=new CPen(PS_SOLID,1,clr);
	pMyBrush6=new CBrush(clr);

	clr=RGB(0,255,0);
	pMyPen7=new CPen(PS_SOLID,1,clr);
	pMyBrush7=new CBrush(clr);

	clr=RGB(0,0,0);
	pMyPen8=new CPen(PS_SOLID,1,clr);
	pMyBrush8=new CBrush(clr);

	GetDlgItem(IDC_STATIC55)->GetWindowRect(&rect5);
	ScreenToClient(&rect5);
	
	imax=xstep*xmax;
	sys_load=new unsigned int [imax];
	
	icur=0;
	sys_load[icur]=0;
	
	tim1=0;

	init();

	status_of_timer1=false;
	
	m_timer = NULL;
	m_timer = SetTimer(ID_TIMER, 1000, NULL);
	
	m_timer1 = NULL;
	m_timer1 = SetTimer(ID_TIMER1, 1000, NULL);

	if ((m_timer==NULL)||(m_timer1==NULL))
	{
		MessageBox(_T("Not enough timers available for this window!"),
				_T("Warning"), MB_ICONEXCLAMATION | MB_OK);

		// signal creation failure...
		OnExit();
	}
	
	if (strcmp(fggcfg->Get(24),"1")==0) OnStartServer();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CWndDlg::OnClose
//		OnClose makes sure the 1sec timer is destroyed when the dialog
//		is closed.

void CWndDlg::OnClose() 
{
	OnStopServer();
	SaveCFG();

	my_close();
	
	CModelessMain::OnClose();
} 

void CWndDlg::SaveCFG(void)
{
	if (strcmp(fggcfg->Get(3),"1")==0)
	{
		CRect rect;
		GetWindowRect(&rect);
	
		char misc[64];
	
		ultoa(rect.left,misc,10);
		fggcfg->Change(1,&misc[0]);
		ultoa(rect.top,misc,10);
		fggcfg->Change(2,&misc[0]);
	}

	fggcfg->Save();
}

void CWndDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	unsigned int pmax=atoi(fggcfg->Get(11));
	if (pmax==0) pmax=max_proc_if_error;

	if (nIDEvent==ID_TIMER1) OnTimer1(pmax);
	else OnTimer0(pmax);

	CModelessMain::OnTimer(nIDEvent);
}

void CWndDlg::OnTimer0(unsigned int pmax)
{
	CString str;
	CDatabase db;
	CRecordset fQuery(&db);
	CDBVariant varValue;

	char str1[StrMaxLen];

	char str1a[DirMaxLen];
	char str1b[DirMaxLen];
	char str1c[DirMaxLen];
	char str1d[DirMaxLen];

	char str2[DirMaxLen];
	char str3[DirMaxLen];

	char dir_app[DirMaxLen];

	TCHAR szError[StrMaxLen];

	int ret;
	bool st;
	
	//Jobs ...
	if (status_of_timer) return;
	
	if (jobs_timer)
	{
		status_of_timer=true;
		
		tim=0;
		DrawReq();

		//For test purposes
		if (strcmp(fggcfg->Get(19),"1")==0) 
		{
			processes=rand()*(pmax+1)/RAND_MAX;
			jobs_timer=false;
			status_of_timer=false;
			return;
		}
				
		//Looking for jobs, which have been finished or
		// must be terminated

		jobs_started=0;
		processes=0;
		//Connecting to database 'Jobs' through ODBC
		try
		{
			//Open database
			if (!db.Open(_TEXT(fggcfg->Get(13)), FALSE, FALSE, _T("ODBC;"), FALSE))
			{
				AfxMessageBox("Fatal Internal Error: Can't connect to database [E010]!");
				OnStopServer();
				goto _end_timer_y;
			}

			strcpy(str1, "SELECT Started.ID_RUN, Started.ID_PROCESS, "
								"Started.ID_MAIN_THREAD, "
								"Started.DATE_TIME_STARTED, "
								"Started.MUST_BE_TERMINATED, "
								"Run.MPI, "
								"Run.PROCESSORS "
						 "FROM Run INNER JOIN Started ON Run.ID_RUN=Started.ID_RUN");
				
			if (!fQuery.Open(AFX_DB_USE_DEFAULT_TYPE, _TEXT(str1)))
			{
				AfxMessageBox("Fatal Internal Error: Can't open Query to database [E020]!");
				OnStopServer();
				goto _end_timer_y;
			}

			if (!fQuery.IsEOF())
			{
				do
				{
					//ID_RUN
					fQuery.GetFieldValue((short) 0, varValue);
			
					if (varValue.m_dwType!=DBVT_LONG)
					{
						AfxMessageBox("Fatal Internal Error: Unknown type of 'ID_RUN' in database [E030]!");
_end_timer_x:
						OnStopServer();
						fQuery.Close();
_end_timer_y:
						db.Close();

						return;
					}
				
					unsigned long id_run=varValue.m_lVal;
				
					//ID_PROCESS
					fQuery.GetFieldValue((short) 1, varValue);
			
					if (varValue.m_dwType!=DBVT_STRING)
					{
						AfxMessageBox("Fatal Internal Error: Unknown type of 'FULLNAME' in database [E040]!");
						goto _end_timer_x;
					}
				
					strcpy(str1,varValue.m_pstring->GetBuffer(StrMaxLen));
					varValue.m_pstring->ReleaseBuffer();
						
					unsigned long prc=atol(str1);

					//ID_MAIN_THREAD
					fQuery.GetFieldValue((short) 2, varValue);
			
					if (varValue.m_dwType!=DBVT_STRING)
					{
						AfxMessageBox("Fatal Internal Error: Unknown type of 'FULLNAME' in database [E050]!");
						goto _end_timer_x;
					}
				
					strcpy(str1,varValue.m_pstring->GetBuffer(StrMaxLen));
					varValue.m_pstring->ReleaseBuffer();
						
					unsigned long thr=atol(str1);

					//DATE_TIME_STARTED
					fQuery.GetFieldValue((short) 3, varValue);
			
					if (varValue.m_dwType!=DBVT_STRING)
					{
						AfxMessageBox("Fatal Internal Error: Unknown type of 'FULLNAME' in database [E060]!");
						goto _end_timer_x;
					}
				
					strcpy(str1,varValue.m_pstring->GetBuffer(StrMaxLen));
					varValue.m_pstring->ReleaseBuffer();
					unsigned long d_t_started=atol(str1);
					
					//MUST_BE_TERMINATED
					fQuery.GetFieldValue((short) 4, varValue);
			
					if (varValue.m_dwType!=DBVT_BOOL)
					{
						AfxMessageBox("Fatal Internal Error: Unknown type of 'MPI' in database [E070]!");
						goto _end_timer_x;
					}
				
					bool must_be_terminated;
	
					if ((varValue.m_boolVal&1)==0) must_be_terminated=false;
					else must_be_terminated=true;

					//MPI
					fQuery.GetFieldValue((short) 5, varValue);
			
					if (varValue.m_dwType!=DBVT_BOOL)
					{
						AfxMessageBox("Fatal Internal Error: Unknown type of 'MPI' in database [E080]!");
						goto _end_timer_x;
					}
				
					bool mpi;
	
					if ((varValue.m_boolVal&1)==0) mpi=false;
					else mpi=true;

					//PROCESSORS
					fQuery.GetFieldValue((short) 6, varValue);
			
					if (varValue.m_dwType!=DBVT_LONG)
					{
						AfxMessageBox("Fatal Internal Error: Unknown type of 'PROCESSORS' in database [E090]!");
						goto _end_timer_x;	
					}
				
					unsigned long processors=varValue.m_lVal;
					if (!mpi) processors=1;

					//Start checking...
					if (must_be_terminated)
					{
						//Job must be terminated
						OnTimer0_RealKill(id_run, prc, thr);

						ret=OnTimer0_KillStarted(id_run);
						if (ret<0) goto _end_timer_x;

						str=_T("Job has been manually terminated!\n");
								
						SaveRes(id_run, str.GetBuffer(StrMaxLen));
						str.ReleaseBuffer();

						ret=OnTimer0_DBReady(id_run);
						if (ret<0) goto _end_timer_x;
					}
					else if (OnTimer0_Finished(thr))
					{
						//Job has been finished 
						ret=OnTimer0_KillStarted(id_run);
						if (ret<0) goto _end_timer_x;

						str=_T("Job has been finished!\n");
								
						SaveRes(id_run, str.GetBuffer(StrMaxLen));
						str.ReleaseBuffer();

						ret=OnTimer0_DBReady(id_run);
						if (ret<0) goto _end_timer_x;
					}
					else if (OnTimer0_TimeOut(d_t_started))
					{
						//Time Out -> Job must be terminated
						OnTimer0_RealKill(id_run, prc, thr);

						ret=OnTimer0_KillStarted(id_run);
						if (ret<0) goto _end_timer_x;

						str=_T("Job has been terminated, because of timeout!\n");
								
						SaveRes(id_run, str.GetBuffer(StrMaxLen));
						str.ReleaseBuffer();

						ret=OnTimer0_DBReady(id_run);
						if (ret<0) goto _end_timer_x;
					}
					else
					{
						jobs_started++;
						processes+=processors;
					}

					fQuery.MoveNext();
				}
				while (!fQuery.IsEOF());
			}
			fQuery.Close();
			db.Close();
		}
		catch (CDBException *pEx)
		{
			str="Fatal Internal Error (while working with database) [E100]:\n";
			if (pEx->GetErrorMessage(szError, sizeof(szError)))
			{
				str+=szError;
			}
			AfxMessageBox(str);
			OnStopServer();
			return;
		}

		//Updating jobs and process
		OnTimer0_Update_j_p();

		//Looking for jobs in queue...
		ret=OnTimer0_JobsInQueue();
		if (ret<0) return;

		jobs=ret;

		//Print number of jobs
		str.Format("%u",jobs);
		GetDlgItem(IDC_STATIC3)->SetWindowText(str);
		UpdateData(false);
				
		if ((jobs!=0)&&(processes<pmax))
		{
			//Connecting to database 'Jobs' through ODBC
			try
			{
				//Open database
				if (!db.Open(_TEXT(fggcfg->Get(13)), FALSE, FALSE, _T("ODBC;"), FALSE))
				{
					AfxMessageBox("Fatal Internal Error: Can't connect to database [E110]!");
					OnStopServer();
					goto _end_timer_b;
				}

				strcpy(str1, "SELECT Run.ID_RUN, Run.ID_USER, "
									"Run.FULLNAME, Run.MPI,  Run.PROCESSORS, "
									"Run.DATE_TIME_RECEIVED, Run.READY, "
									"Run.MAY_BE_KILLED, Accounts.FTP_ROOT_DIR "
							"FROM Accounts INNER JOIN Run ON Accounts.ID_USER=Run.ID_USER "
							"WHERE (((Run.READY)=No) AND ((Run.MAY_BE_KILLED)=No) AND ((Accounts.ACTIVE)=Yes)) "
							"ORDER BY Accounts.PRIORITY, Run.DATE_TIME_RECEIVED");
				
				if (!fQuery.Open(AFX_DB_USE_DEFAULT_TYPE, _TEXT(str1)))
				{
					AfxMessageBox("Fatal Internal Error: Can't open Query to database [E120]!");
					OnStopServer();
					goto _end_timer_b;
				}

				if (!fQuery.IsEOF())
				{
					do
					{
						//ID_RUN
						fQuery.GetFieldValue((short) 0, varValue);
			
						if (varValue.m_dwType!=DBVT_LONG)
						{
							AfxMessageBox("Fatal Internal Error: Unknown type of 'ID_RUN' in database [E130]!");
_end_timer_a:
							OnStopServer();
							fQuery.Close();
_end_timer_b:
							db.Close();

							return;
						}
				
						unsigned long id_run=varValue.m_lVal;

						st=true;

						//Checking if already started
						if (!OnTimer0_JobsInQueueStarted(id_run))
						{
							//ID_USER
							fQuery.GetFieldValue((short) 1, varValue);
			
							if (varValue.m_dwType!=DBVT_LONG)
							{
								AfxMessageBox("Fatal Internal Error: Unknown type of 'ID_USER' in database [E140]!");
								goto _end_timer_a;	
							}
				
							unsigned long id_user=varValue.m_lVal;

							//FULLNAME
							fQuery.GetFieldValue((short) 2, varValue);
			
							if (varValue.m_dwType!=DBVT_STRING)
							{
								AfxMessageBox("Fatal Internal Error: Unknown type of 'FULLNAME' in database [E150]!");
								goto _end_timer_a;
							}
				
							char fullname[StrMaxLen];
						
							strcpy(fullname,varValue.m_pstring->GetBuffer(StrMaxLen));
							varValue.m_pstring->ReleaseBuffer();

							//MPI
							fQuery.GetFieldValue((short) 3, varValue);
			
							if (varValue.m_dwType!=DBVT_BOOL)
							{
								AfxMessageBox("Fatal Internal Error: Unknown type of 'MPI' in database [E160]!");
								goto _end_timer_a;
							}
				
							bool mpi;
	
							if ((varValue.m_boolVal&1)==0) mpi=false;
							else mpi=true;

							//PROCESSORS
							fQuery.GetFieldValue((short) 4, varValue);
			
							if (varValue.m_dwType!=DBVT_LONG)
							{
								AfxMessageBox("Fatal Internal Error: Unknown type of 'PROCESSORS' in database [E170]!");
								goto _end_timer_a;	
							}
				
							unsigned long processors=varValue.m_lVal;

							//FTP ROOT DIR
							fQuery.GetFieldValue((short) 8, varValue);
			
							if (varValue.m_dwType!=DBVT_STRING)
							{
								AfxMessageBox("Fatal Internal Error: Unknown type of 'FTP_ROOT_DIR' in database [E180]!");
								goto _end_timer_a;
							}
				
							char ftp_root_dir[StrMaxLen];

							strcpy(ftp_root_dir,varValue.m_pstring->GetBuffer(StrMaxLen));
							varValue.m_pstring->ReleaseBuffer();
							
							if (!mpi) processors=1;

							//Checking if job does not exceed max processes
							if (processes+processors<=pmax)
							{
								//Starting job
								add_dir(dir_app, fggcfg->Get(14), true);
								add_dir(dir_app, ftp_root_dir, false);

								strcpy(str1, dir_app);
								
								_splitpath(fullname, str1a, str1b, str1c, str1d);
							
								add_dir(dir_app, str1b, false);
								strcat(str1, fullname);
								
								//Looking for file to execute:
								struct _finddata_t ff;

								long nextf=_findfirst(str1,&ff);
								if (nextf==-1)
								{
									str="FATAL ERROR: Executable file not found!";
_end_timer_er:
									str+=_T("\n");
								
									SaveRes(id_run, str.GetBuffer(StrMaxLen));
									str.ReleaseBuffer();

									ret=OnTimer0_DBReady(id_run);
									if (ret<0) goto _end_timer_a;	
								}
								else
								{
									if (mpi)
									{
										if (strcmp(fggcfg->Get(20),"0")==0)
										{
											//Win 95
											strcpy(str2, "command.com /C ");
										}
										else
										{
											//Win NT
											strcpy(str2,"");
										}
																		
										strcat(str2, fggcfg->Get(17));
										strcat(str2, " ");
										strcat(str2, fggcfg->Get(18));
										strcat(str2, " ");
										ultoa(processors, str1a, 10);
										strcat(str2, str1a);
										strcat(str2, " ");
										strcat(str2,str1);

										strcpy(str1,str2);
									}

									//Preparing to start!
									PROCESS_INFORMATION pi;						
									STARTUPINFO si = {0};
									si.cb = sizeof(si);
									
									//Set output file
									HANDLE m_hFile=NULL;

									add_dir(str2, fggcfg->Get(15), true);
									ultoa(id_run, str1a, 10);
									strcat(str2, str1a);
									strcat(str2, fggcfg->Get(22));

									if (mpi)
									{
										strcpy(str3, fggcfg->Get(17));
										_splitpath(str3, str1a, str1b, str1c, str1d);
							
										strcpy(str3, str1a);
										add_dir(str3, str1b, false);
										strcat(str3, fggcfg->Get(23));
										
										ofstream fout(str3);

										if (fout)
										{
											fout << str2;
											
											fout.close();
										}
									}
									else
									{
											SECURITY_ATTRIBUTES g_sa = {sizeof(SECURITY_ATTRIBUTES),NULL,TRUE};
		
											m_hFile = CreateFile(str2 , 
												GENERIC_WRITE,
												FILE_SHARE_WRITE, 
												&g_sa,
												CREATE_ALWAYS, 
												FILE_ATTRIBUTE_NORMAL, 
												NULL);
									
											si.dwFlags |= STARTF_USESTDHANDLES;
											si.hStdInput=NULL;
											si.hStdOutput=m_hFile;
											si.hStdError=m_hFile;
									}
									
									//Starting job!
									strcpy(str2, "SCS_S_R ID=");
									ultoa(id_run, str1a, 10);
									strcat(str2, str1a);
									si.lpTitle=str2;
									si.dwFlags |= STARTF_USESHOWWINDOW;
									si.wShowWindow=SW_MINIMIZE;

									DWORD dwCreateFlags = 
										CREATE_DEFAULT_ERROR_MODE | 
										CREATE_NEW_CONSOLE |
										CREATE_NEW_PROCESS_GROUP;
									
									if (strcmp(fggcfg->Get(25),"1")==0) dwCreateFlags |= IDLE_PRIORITY_CLASS;
	
									BOOL bOk = CreateProcess( NULL, str1,
												NULL, NULL, TRUE,
												dwCreateFlags, NULL, 
												dir_app, &si, &pi );

									if (m_hFile!=NULL) CloseHandle(m_hFile);
									
									// if succesfully created...
									if (bOk)
									{
										DWORD thr=pi.dwThreadId;
										DWORD prc=pi.dwProcessId;
									
										// release our hold on the thread & process....
										CloseHandle(pi.hThread);
										CloseHandle(pi.hProcess);
									
										//Refresh number of process!
										jobs_started++;
										processes+=processors;

										OnTimer0_Update_j_p();

										ret=OnTimer0_Success(id_run, thr, prc);
										if (ret<0) goto _end_timer_a;	

										st=false;
									}
									else
									{
										str="FATAL ERROR: Can't start your job:\n";

										DWORD dwErr = GetLastError();

										switch (dwErr)
										{
											case ERROR_FILE_NOT_FOUND:
														str+="The system cannot find executable file!";
														break;

											case ERROR_PATH_NOT_FOUND:
														str+="The system cannot find the path to the file (to run)!";
														break;

											case ERROR_ACCESS_DENIED:
														str+="Access is denied!";
														break;
 
											case ERROR_NOT_ENOUGH_MEMORY:
														str+="Not enough storage is available to process this command!";
														break;

											case ERROR_BAD_ENVIRONMENT:
														str+="The environment is incorrect!";
														break;

											case ERROR_BAD_FORMAT:
														str+="An attempt was made to load a program with an incorrect format!";
														break;

											case ERROR_OUTOFMEMORY:
														str+="Not enough storage is available to complete this operation!";
														break;

											case ERROR_INVALID_DRIVE:
														str+="The system cannot find the drive specified!";
														break;

											case ERROR_BAD_UNIT:
														str+="The system cannot find the device specified!";
														break;

											case ERROR_NOT_READY:
														str+="The device is not ready!";
														break;

											case ERROR_BAD_COMMAND:
														str+="The device does not recognize the command!";

											default:
														str+="Error number: ";
														ultoa(dwErr, str1a, 10);
														str+=_TEXT(str1a);
														break;
										}

										goto _end_timer_er;
									}
								}
							}
						}
						fQuery.MoveNext();
					}
					while (st&&!fQuery.IsEOF());

					fQuery.Close();
				}
				db.Close();
			}
			catch (CDBException *pEx)
			{
				str="Fatal Internal Error (while working with database) [E190]:\n";
				if (pEx->GetErrorMessage(szError, sizeof(szError)))
				{
					str+=szError;
				}
				AfxMessageBox(str);
				OnStopServer();
				return;
			}
		}

		//Checking for activity
		//if ((jobs==0)&&(jobs_started==0)&&(processes==0)) jobs_timer=false;
		jobs_timer=false;
		
		status_of_timer=false;
	}
	else if ((!suspended)&&(working))
	{
		status_of_timer=true;
		tim++;

		str.Format("%u",tim);
		GetDlgItem(IDC_STATIC1)->SetWindowText(str);

		if (tim>=tim_max) 
		{
			tim=0;
			DrawReq();
		
			jobs_timer=true;
		}
		else DrawIdle();
		
		status_of_timer=false;
	}
}

void CWndDlg::OnTimer0_RealKill(unsigned long id_run, unsigned long prc, unsigned long thr)
{
	if (!OnTimer0_Finished(thr))
	{
		if (strcmp(fggcfg->Get(20),"0")==0)
		{
			//Win 95
			HANDLE hnd=OpenProcess(PROCESS_ALL_ACCESS, TRUE, prc);
			TerminateProcess(hnd, 99);
			
			CloseHandle(hnd);
		}
		else
		{
			//Win NT
			HWND wnd=GetWnd();
			if (wnd!=NULL) ::SendMessage(wnd, WM_CLOSE, 0, 0);
		}
	}
}

void CWndDlg::OnTimer0_Update_j_p(void)
{
	CString str;
	
	str.Format("%u",jobs_started);
	GetDlgItem(IDC_STATIC7)->SetWindowText(str);
	UpdateData(false);
			
	str.Format("%u",processes);
	GetDlgItem(IDC_STATIC8)->SetWindowText(str);
	UpdateData(false);
}

//Return: true, if finished
bool CWndDlg::OnTimer0_Finished(unsigned long thr)
{
    HWND hwndList; //Only for the standard call of the function AddOneWindow
	
	SetWnd(NULL);
	SetMyThread(thr);
	SetFound(false);
	EnumWindows(AddOneWindow, (LPARAM)hwndList);
	
	return !GetFound();
}

//Return: true, if timeout
bool CWndDlg::OnTimer0_TimeOut(unsigned long time_started)
{                             
	time_t time_current;
	
	double timeout=atol(fggcfg->Get(21));
	
	time(&time_current); /* Get time as long integer. */
	double diff=difftime(time_current, time_started);
	if (diff>timeout) return true;
	
	return false;
}

//Return: -1 - Error
int CWndDlg::OnTimer0_KillStarted(unsigned long id_run)
{
	CString str;

	CDatabase db;
	
	char str1[StrMaxLen];
	char str1a[StrMaxLen];
	TCHAR szError[StrMaxLen];

	try
	{
		//Open database
		if (!db.Open(_TEXT(fggcfg->Get(13)), FALSE, FALSE, _T("ODBC;"), FALSE))
		{
			AfxMessageBox("Fatal Internal Error: Can't connect to database [E200]!");
			OnStopServer();
			return -1;
		}

		strcpy(str1,"DELETE FROM Started "
					"WHERE Started.ID_RUN=");

		ultoa(id_run, str1a, 10);
		strcat(str1, str1a);
		
		db.ExecuteSQL(_TEXT(str1));
		db.Close();
	}
	catch (CDBException *pEx)
	{
		str="Fatal Internal Error (while working with database) [E210]:\n";
		if (pEx->GetErrorMessage(szError, sizeof(szError)))
		{
			str+=szError;
		}
		AfxMessageBox(str);
		OnStopServer();
		return -1;
	}
	
	return 0;
}

//Return: -1 - Error
int CWndDlg::OnTimer0_Success(unsigned long id_run, DWORD thr, DWORD prc)
{
	CString str;

	CDatabase db;
	
	char str1[StrMaxLen];
	char str1a[StrMaxLen];
	TCHAR szError[StrMaxLen];

	try
	{
		//Open database
		if (!db.Open(_TEXT(fggcfg->Get(13)), FALSE, FALSE, _T("ODBC;"), FALSE))
		{
			AfxMessageBox("Fatal Internal Error: Can't connect to database [E220]!");
			OnStopServer();
			return -1;
		}

		strcpy(str1,"INSERT INTO Started (ID_RUN, ID_PROCESS, ID_MAIN_THREAD, DATE_TIME_STARTED, MUST_BE_TERMINATED)"
			        " VALUES (");

		ultoa(id_run, str1a, 10);
		strcat(str1, str1a);
		strcat(str1,",'");
		
		ultoa(prc, str1a, 10);
		strcat(str1, str1a);
		strcat(str1,"','");

		ultoa(thr, str1a, 10);
		strcat(str1, str1a);
		strcat(str1,"','");

		time_t long_time;
		time(&long_time); /* Get time as long integer. */
		ultoa(long_time, str1a, 10);
		strcat(str1, str1a);

		strcat(str1, "',");

		strcat(str1, "No)");

		db.ExecuteSQL(_TEXT(str1));
		db.Close();

	}
	catch (CDBException *pEx)
	{
		str="Fatal Internal Error (while working with database) [E230]:\n";
		if (pEx->GetErrorMessage(szError, sizeof(szError)))
		{
			str+=szError;
		}
		AfxMessageBox(str);
		OnStopServer();
		return -1;
	}
	
	return 0;
}

//Return: -1 - Error, else true, if started!
int CWndDlg::OnTimer0_JobsInQueueStarted(unsigned long id_run)
{
	CString str;
	CDatabase db;
	CRecordset fQuery(&db);

	char str1[StrMaxLen];
	char str1a[StrMaxLen];
	TCHAR szError[StrMaxLen];
	
	unsigned int xstarted=false;
	
	//Connecting to database 'Jobs' through ODBC
	try
	{
		//Open database
		if (!db.Open(_TEXT(fggcfg->Get(13)), FALSE, FALSE, _T("ODBC;"), FALSE))
		{
			AfxMessageBox("Fatal Internal Error: Can't connect to database [E240]!");
			OnStopServer();
			return -1;
		}

		strcpy(str1, "SELECT Started.* FROM Started "
		             "WHERE (((Started.ID_RUN)=");
		ultoa(id_run, str1a, 10);
		strcat(str1, str1a);
		strcat(str1,") AND ((Started.MUST_BE_TERMINATED)=No)) ");

		if (!fQuery.Open(AFX_DB_USE_DEFAULT_TYPE, _TEXT(str1)))
		{
			AfxMessageBox("Fatal Internal Error: Can't open Query to database [E250]!");
			OnStopServer();
			return -1;
		}
		else 
		{
			if (!fQuery.IsEOF()) xstarted=true;
			fQuery.Close();
		}
			
		db.Close();
	}
	catch (CDBException *pEx)
	{
		str="Fatal Internal Error (while working with database) [E260]:\n";
		if (pEx->GetErrorMessage(szError, sizeof(szError)))
		{
			str+=szError;
		}
		AfxMessageBox(str);
		OnStopServer();
		return -1;
	}

	return xstarted;
}

//Return: -1 - Error, else true, if there are jobs to terminate!
int CWndDlg::OnTimer0_DBStart(unsigned long id_run)
{
	CString str;
	CDatabase db;
	CRecordset fQuery(&db);

	char str1[StrMaxLen];
	TCHAR szError[StrMaxLen];
	
	unsigned int xterminated=false;
	
	//Connecting to database 'Jobs' through ODBC
	try
	{
		//Open database
		if (!db.Open(_TEXT(fggcfg->Get(13)), FALSE, FALSE, _T("ODBC;"), FALSE))
		{
			AfxMessageBox("Fatal Internal Error: Can't connect to database [E270]!");
			OnStopServer();
			return -1;
		}

		strcpy(str1, "SELECT Started.* FROM Started "
		             "WHERE ((Started.MUST_BE_TERMINATED)=Yes)");

		if (!fQuery.Open(AFX_DB_USE_DEFAULT_TYPE, _TEXT(str1)))
		{
			AfxMessageBox("Fatal Internal Error: Can't open Query to database [E280]!");
			OnStopServer();
			return -1;
		}
		else 
		{
			if (!fQuery.IsEOF()) xterminated=true;
			fQuery.Close();
		}
			
		db.Close();
	}
	catch (CDBException *pEx)
	{
		str="Fatal Internal Error (while working with database) [E290]:\n";
		if (pEx->GetErrorMessage(szError, sizeof(szError)))
		{
			str+=szError;
		}
		AfxMessageBox(str);
		OnStopServer();
		return -1;
	}

	return xterminated;
}

//Return: -1 - Error, else true, if there are jobs to terminate!
int CWndDlg::OnTimer0_DBReady(unsigned long id_run)
{
	CString str;
	CDatabase db;

	char str1[StrMaxLen];
	char str1a[StrMaxLen];
	TCHAR szError[StrMaxLen];
	
	unsigned int xterminated=false;
	
	//Connecting to database 'Jobs' through ODBC
	try
	{
		//Open database
		if (!db.Open(_TEXT(fggcfg->Get(13)), FALSE, FALSE, _T("ODBC;"), FALSE))
		{
			AfxMessageBox("Fatal Internal Error: Can't connect to database [E300]!");
			OnStopServer();
			return -1;
		}

		strcpy(str1,"UPDATE Run "
			        "SET Run.READY=Yes, "
				        "Run.DATE_TIME_COMPLETED='");

		_strdate(str1a);
		strcat(str1, str1a);
		strcat(str1," ");
	
		_strtime(str1a);
		strcat(str1, str1a);
		strcat(str1, "' "
		             "WHERE Run.ID_RUN=");

		ultoa(id_run, str1a, 10);
		strcat(str1, str1a);

		db.ExecuteSQL(_TEXT(str1));
		db.Close();
	}
	catch (CDBException *pEx)
	{
		str="Fatal Internal Error (while working with database) [E310]:\n";
		if (pEx->GetErrorMessage(szError, sizeof(szError)))
		{
			str+=szError;
		}
		AfxMessageBox(str);
		OnStopServer();
		return -1;
	}

	return 0;
}

//Return: -1 - Error, else number of jobs in queue
int CWndDlg::OnTimer0_JobsInQueue(void)
{
	CString str;
	CDatabase db;
	CRecordset fQuery(&db);

	char str1[StrMaxLen];
	TCHAR szError[StrMaxLen];
	
	unsigned int xjobs=0;
	
	//Connecting to database 'Jobs' through ODBC
	try
	{
		//Open database
		if (!db.Open(_TEXT(fggcfg->Get(13)), FALSE, FALSE, _T("ODBC;"), FALSE))
		{
			AfxMessageBox("Fatal Internal Error: Can't connect to database [E320]!");
			OnStopServer();
			return -1;
		}

		strcpy(str1, "SELECT Run.ID_RUN, Run.ID_USER, "
							"Run.FULLNAME, Run.MPI,  Run.PROCESSORS, "
					        "Run.DATE_TIME_RECEIVED, Run.READY, "
					        "Run.MAY_BE_KILLED "
		             "FROM Accounts INNER JOIN Run ON Accounts.ID_USER=Run.ID_USER "
		             "WHERE (((Run.READY)=No) AND ((Run.MAY_BE_KILLED)=No) AND ((Accounts.ACTIVE)=Yes)) "
					 "ORDER BY Accounts.PRIORITY");

		if (!fQuery.Open(AFX_DB_USE_DEFAULT_TYPE, _TEXT(str1)))
		{
			AfxMessageBox("Fatal Internal Error: Can't open Query to database [E330]!");
			OnStopServer();
			return -1;
		}
		else 
		{
			if (!fQuery.IsEOF())
			{
				while (!fQuery.IsEOF())
				{
					xjobs++;
					fQuery.MoveNext();
				}
			}
			fQuery.Close();
		}
			
		db.Close();
	}
	catch (CDBException *pEx)
	{
		str="Fatal Internal Error (while working with database) [E340]:\n";
		if (pEx->GetErrorMessage(szError, sizeof(szError)))
		{
			str+=szError;
		}
		AfxMessageBox(str);
		OnStopServer();
		return -1;
	}

	return xjobs;
}

void CWndDlg::OnTimer1(unsigned int pmax)
{
	//Timer
	if (!status_of_timer1)
	{
		//Drawing load
		status_of_timer1=true;
		
		tim1++;

		DrawLoadClear();
		//DrawLoad(false);
		DrawLoadLines();

		if (tim1>=tim1_max) 
		{
			tim1=0;
		
			icur++;
			if (icur>imax) icur=imax;
		
			for (int i=imax-1; i>=0; i--) sys_load[i+1]=sys_load[i];
			sys_load[0]=processes; //rand()*(pmax+1)/RAND_MAX;
		}

		DrawLoad(true);					

		status_of_timer1=false;
	}
}

void CWndDlg::init(void)
{
	jobs_timer=false;
	working=false;
	suspended=false;
	status_of_timer=false;
	
	tim=0;
	tim_max=atoi(fggcfg->Get(10));
	
	CString str;
	str.Format("%u",tim_max);
	m_st1.SetWindowText(_T("0"));
	m_st2.SetWindowText(_TEXT(str));
	m_st3.SetWindowText(_T("0"));
	m_st4.SetWindowText(_T("0"));
	m_st5.SetWindowText(_T("0"));

	tim1_max=atoi(fggcfg->Get(12));
	
	jobs=0;
	jobs_started=0;
	processes=0;
	
	DrawClear();
	
	UpdateData(false);
}

void CWndDlg::OnStartServer() 
{
	// TODO: Add your command handler code here
	init();

	working=true;
}

void CWndDlg::OnStopServer() 
{
	// TODO: Add your command handler code here
	init();

	working=false;
}

void CWndDlg::OnUpdateStartServer(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!working);
}

void CWndDlg::OnUpdateStopServer(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(working);
}

void CWndDlg::my_close(void) 
{
	if (m_timer)
	{
		KillTimer(m_timer);
		m_timer = NULL;
	}

	if (m_timer1)
	{
		KillTimer(m_timer1);
		m_timer1 = NULL;
	}
}

void CWndDlg::DrawIdle(void)
{
	// TODO: Add your message handler code here and/or call default
	pDC->SelectObject(pMyPen1);
	pDC->SelectObject(pMyBrush1);
	pDC->Ellipse(rect1.left,rect1.top,rect1.left+ir1,rect1.top+ir1);

	pDC->SelectObject(pMyPen2);
	pDC->SelectStockObject(LTGRAY_BRUSH);
	pDC->Ellipse(rect2.left,rect2.top,rect2.left+ir2,rect2.top+ir2);

	UpdateData(false);
}

void CWndDlg::DrawReq(void)
{
	// TODO: Add your message handler code here and/or call default
	pDC->SelectObject(pMyPen2);
	pDC->SelectObject(pMyBrush2);
	pDC->Ellipse(rect2.left,rect2.top,rect2.left+ir2,rect2.top+ir2);

	pDC->SelectObject(pMyPen1);
	pDC->SelectStockObject(LTGRAY_BRUSH);
	pDC->Ellipse(rect1.left,rect1.top,rect1.left+ir1,rect1.top+ir1);

	UpdateData(false);
}

void CWndDlg::DrawClear(void)
{
	// TODO: Add your message handler code here and/or call default
	pDC->SelectObject(pMyPen3);
	pDC->SelectStockObject(LTGRAY_BRUSH);
	pDC->Rectangle(rect1.left-1,rect1.top-1,rect1.left+ir1+1,rect1.top+ir1+1);
	pDC->Rectangle(rect2.left-1,rect2.top-1,rect2.left+ir2+1,rect2.top+ir2+1);

	UpdateData(false);
}

void CWndDlg::OnAbout() 
{
	// TODO: Add your command handler code here
	suspended=true;

	CAbout about;
	about.DoModal();

	suspended=false;
}

void CWndDlg::OnExit() 
{
	// TODO: Add your command handler code here
	OnStopServer();
	SaveCFG();	

	my_close();
	
	exit(0);
}

void CWndDlg::OnOptionsServer() 
{
	// TODO: Add your command handler code here
	suspended=true;
	
	COptServ OptServ;
	if (OptServ.DoModal()==IDOK) OnStopServer();

	suspended=false;
}

void CWndDlg::OnOptionsWindow() 
{
	// TODO: Add your command handler code here
	suspended=true;
	
	COptWnd OptWnd;
	OptWnd.DoModal();

	suspended=false;
}

void CWndDlg::OnUpdateAbout(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!jobs_timer);	
}

void CWndDlg::OnUpdateOptionsServer(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!jobs_timer);
}

void CWndDlg::OnUpdateOptionsWindow(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!jobs_timer);
}

void CWndDlg::DrawLoadClear(void)
{
	pDC->SelectObject(pMyPen5);
	pDC->SelectObject(pMyBrush5);
	
	pDC->Rectangle(rect5.left, rect5.top, rect5.right, rect5.bottom);

	UpdateData(false);
}

void CWndDlg::DrawLoadLines(void)
{
	pDC->SelectObject(pMyPen6);
	pDC->SelectObject(pMyBrush6);
	
	unsigned int x1=rect5.left;
	unsigned int y1=rect5.top;
	unsigned int x2=rect5.right;
	unsigned int y2=rect5.bottom;

	unsigned int pmax=atoi(fggcfg->Get(11));
	if (pmax==0) pmax=max_proc_if_error;
	
	double stepy=(double) (y2-y1)/pmax;

	for (unsigned int y=0; y<=pmax; y++)
	{
		double stepyy=stepy*y;
		unsigned int yq=y1+(int) stepyy;
		pDC->MoveTo(rect5.left, yq);
		pDC->LineTo(rect5.right+1, yq);
	}
	
	double stepx=(double) (x2-x1)/xmax;

	for (unsigned int x=0; x<=xmax; x++)
	{
		double stepxx=stepx*x;
		unsigned int xq=x1+(int) stepxx;
		pDC->MoveTo(xq, rect5.bottom);
		pDC->LineTo(xq, rect5.top);
		
		int xa=1;
		if (x==xmax) xa=-1;
		pDC->MoveTo(xq+xa, rect5.bottom);
		pDC->LineTo(xq+xa, rect5.top);
	}
	
	UpdateData(false);
}

void CWndDlg::DrawLoad(bool param)
{
	if (param)
	{
		pDC->SelectObject(pMyPen7);
		pDC->SelectObject(pMyBrush7);
	}
	else
	{
		pDC->SelectObject(pMyPen8);
		pDC->SelectObject(pMyBrush8);
	}
	
	unsigned int x1=rect5.left;
	unsigned int y1=rect5.top;
	unsigned int x2=rect5.right;
	unsigned int y2=rect5.bottom;
	
	unsigned int pmax=atoi(fggcfg->Get(11));
	if (pmax==0) pmax=max_proc_if_error;

	double stepy=(double) (y2-y1)/pmax;
	double stepx=(double) (x2-x1)/imax;

	if (icur>imax) icur=imax;
	
	for (unsigned int i=0; i<=icur; i++)
	{
		unsigned int ld=sys_load[i];
		if (ld>pmax) ld=pmax;
		
		double stepyy=stepy*(pmax-ld);
		unsigned int yq=y1+(int) stepyy;

		double stepxx=stepx*(imax-i);
		unsigned int xq=x1+(int) stepxx;

		if (i==0) pDC->MoveTo(xq, yq);
		pDC->LineTo(xq, yq);
	}
	
	UpdateData(false);
}

// Return: -1, if error
int CWndDlg::SaveRes(unsigned long id_run, char *str)
{
	char str1[StrMaxLen];
	char str1a[StrMaxLen];
	
	//Set file with results
	add_dir(str1, fggcfg->Get(15), true);
	ultoa(id_run, str1a, 10);
	strcat(str1, str1a);
	strcat(str1, fggcfg->Get(16));
	
	ofstream fout1(str1);
			
	if (!fout1)
	{
		AfxMessageBox("Fatal Internal Error: Can't open result file for 'run' job [E350]!");
		OnStopServer();
		return -1;
	}

	fout1 << str << '\n';

	fout1.close();

	return 0;
}

void CWndDlg::OnKillJob() 
{
	// TODO: Add your command handler code here
	suspended=true;
	
	CKillJob KillJob;
	KillJob.DoModal();

	suspended=false;
}

void CWndDlg::OnUpdateKillJob(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!jobs_timer);
}
