#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <tchar.h>
#include <winsock.h>
#include "service.h"
#include "processinfo.h"
#include "mpiserve.h"
#include "SocketReadAndWrite.h"
#include "MPIServePacket.h"
#include "packets.h"
#include "infoprint.h"
#include "mpirun.h"
#include "crtdbg.h"
#include "debuglog.h"

extern BOOL fDebug;

DWORD CreateShmemBuf(HANDLE *hShmemBuf)
{
	DWORD dwStatus = ERROR_SUCCESS;
	MPID_WINNT_SHMEM_BUFFER_T *pBuf;
	SECURITY_ATTRIBUTES sa;

	_ASSERTE(hShmemBuf);

	sa.nLength = sizeof(SECURITY_ATTRIBUTES);
	sa.lpSecurityDescriptor = NULL;
	sa.bInheritHandle = TRUE;

	*hShmemBuf = CreateFileMapping((HANDLE) 0xFFFFFFFF,	/* create a new one */
								  &sa,					/* null security attributes */
								  PAGE_READWRITE | SEC_NOCACHE | SEC_COMMIT,	/* read and write to the memory */
								  0,						/* high order bits */
								  sizeof(MPID_WINNT_SHMEM_BUFFER_T),/* low order bits */
								  NULL);					/* no name */
	_ASSERTE(*hShmemBuf);
	if (NULL == *hShmemBuf)
	{
		char szMsg[256];
		sprintf(szMsg,"Unable to create Shared Memory Buffer for Message Passing!  Error [%d].  Exitting...\n",GetLastError());
		if (fDebug)
			WriteDebugLog(szMsg);
		goto reporterror;
	}
	pBuf = (MPID_WINNT_SHMEM_BUFFER_T *)MapViewOfFile(*hShmemBuf,
													  FILE_MAP_ALL_ACCESS,											   /* all access */
													  0,															   /* high order bits */
													  0,															   /* low order bits */
													  0);															   /* map the whole file */
	_ASSERTE(pBuf);
	if (NULL == pBuf)
	{
		if (fDebug)
			WriteDebugLog("Unable to Map View of Shared Memory Buffer!  Exitting...\n");
		goto reporterror;
	}
	if (fDebug)
		WriteDebugLog("\tCreating buffer empty event");
	pBuf->hBufferEmpty = CreateEvent(&sa,
									 FALSE,
									 TRUE,
									 NULL);
	_ASSERTE(pBuf->hBufferEmpty);
	if (NULL == pBuf->hBufferEmpty)
		goto reporterror;
	if (fDebug)
		WriteDebugLog("\tCreating buffer full event");
	pBuf->hBufferFull = CreateEvent(&sa,
									FALSE,
									FALSE,
									NULL);
	_ASSERTE(pBuf->hBufferFull);
	if (NULL == pBuf->hBufferFull)
		goto reporterror;
	if (fDebug)
		WriteDebugLog("\tCreating mutex");
	pBuf->hMutex = CreateMutex(&sa,
							   FALSE,
							   NULL);
	_ASSERTE(pBuf->hMutex);
	if (NULL == pBuf->hMutex)
		goto reporterror;

	UnmapViewOfFile(pBuf);		

reporterror:
	dwStatus = GetLastError();
	return dwStatus;
}

