#include "windows.h"
#include "packets.h"
#include "processinfo.h"
#include "infoprint.h"
#include "crtdbg.h"

DWORD PrintWorldProcessMap(WORLDPROCESSMAP *WPM)
{
	DWORD i;

	printf("\n\n****  WorldProcessMap  ****\n\n");

	printf("WorldProcessMap->dwNumProcs ==\t[%d]\n",WPM->dwNumProcs);
	for (i=0; i < WPM->dwNumProcs; i++)
	{
		printf("WorldProcessMap->Process[%d]\n",i);
		printf("\tdwMachineNumber     [%d]\n",WPM->Process[i].dwMachineNumber);
		printf("\tdwLocalBufferNumber [%d]\n",WPM->Process[i].dwLocalBufferNumber);
	}
	return (DWORD)1;
}

DWORD PrintJobInfo(JOBINFO *JI)
{
	DWORD i,j;

	printf("\n\n****  JobInfo  ****\n\n");

	printf("JobInfo->hBarrierSemaphore      [%d]\n",JI->hBarrierSemaphore);
	printf("JobInfo->hBarrierEvent          [%d]\n",JI->hBarrierEvent);
	printf("JobInfo->hGlobalTerminatorEvent [%d]\n",JI->hGlobalTerminatorEvent);
	printf("JobInfo->dwNumMachines          [%d]\n",JI->dwNumMachines);
	printf("JobInfo->dwWorldSize            [%d]\n",JI->dwWorldSize);
	printf("JobInfo->dwMyMachineID          [%d]\n",JI->dwMyMachineID);
	for (i=0; i < JI->dwNumMachines; i++)
	{
		printf("JobInfo->Machine [%d]\n",i);
		printf("\tszMachineName  [%s]\n",JI->Machine[i].szMachineName);
		printf("\tdwNumProcesses [%d]\n",JI->Machine[i].dwNumProcesses);
		for (j=0; j < JI->Machine[i].dwNumProcesses; j++)
		{
			printf("\tProcess    [%d]\n",j);
			printf("\t\tExecutable          [%s]\n",JI->Machine[i].Process[j].szExecutable);
			printf("\t\tdwLocalBufferNumber [%d]\n",JI->Machine[i].Process[j].dwLocalBufferNumber);
			printf("\t\tdwMachineNumber     [%d]\n",JI->Machine[i].Process[j].dwMachineNumber);
			printf("\t\tdwGlobalRank        [%d]\n",JI->Machine[i].Process[j].dwGlobalRank);
			printf("\t\thSharedMemoryBuffer [%d]\n",JI->Machine[i].Process[j].hSharedMemoryBuffer);
		}
	}

	return (DWORD)1;
}

void PrintPacket(MPID_PKT_T *pPkt)
{
	printf("Packet:\n");
	printf("\tmode:\t\t[%d]\n",pPkt->head.mode);
	printf("\tsrc:\t\t[%d]\n",pPkt->head.src);
	printf("\tcontext_id:\t[%d]\n",pPkt->head.context_id);
	printf("\tlrank:\t\t[%d]\n",pPkt->head.lrank);
	printf("\ttag:\t\t[%d]\n",pPkt->head.tag);
	printf("\tlen:\t\t[%d]\n",pPkt->head.len);
}


void PrintShmemBuffer(MPID_WINNT_SHMEM_BUFFER_T *pBuf)
{
	printf("ShmemBuffer\n");
	printf("\thMutex       [%d]\n",pBuf->hMutex);
	printf("\thBufferFull  [%d]\n",pBuf->hBufferFull);
	printf("\thBufferEmpty [%d]\n",pBuf->hBufferEmpty);
	PrintPacket(&(pBuf->Packet));
}

