#include "windows.h"
#include "packets.h"
#include "processinfo.h"
#include "infoprint.h"
#include "mpirun.h"
#include "mpiservepacket.h"
#include "SocketReadAndWrite.h"
#include "mpiserve.h"
#include "crtdbg.h"

extern BOOL fDebug;
extern BOOL fWait;
extern char szMachineName[MAXPATHLEN];
extern char szExecutable[MAXPATHLEN];

DWORD KillSingleProc(int argc,char *argv[])
{
	DWORD dwStatus = ERROR_SUCCESS;
	int nNumBytes;
	int nServerFunction = MPI_SERVE_KILL_SINGLE_PROCESS;
	SOCKET s;
	SOCKADDR_IN aAddress;
	struct hostent *pheEnt;
	WORD wPortNumber;
	MPIServeKillSingleProcessPacket_T KSPPacket;
	MPIServeKillSingleProcessReturnDataPacket_T KSPRDPacket;

	dwStatus = (DWORD)GetPortNumber(&wPortNumber);
	_ASSERTE(ERROR_SUCCESS == dwStatus);
	if (ERROR_SUCCESS == dwStatus)
	{
		KSPPacket.hProcess = (HANDLE)atol(argv[3]);
		KSPPacket.dwExitCode = (DWORD)-1;

		pheEnt = gethostbyname(szMachineName);
		if (NULL == pheEnt)
			goto cleanup;
		aAddress.sin_port = htons(wPortNumber);
		aAddress.sin_family = AF_INET;
		memcpy(&aAddress.sin_addr,pheEnt->h_addr,pheEnt->h_length);
		s = socket(pheEnt->h_addrtype,SOCK_STREAM,0);
		if (INVALID_SOCKET == s)
			goto cleanup;
		dwStatus = (DWORD)connect(s,(PSOCKADDR)&aAddress,sizeof(SOCKADDR_IN));
		if (SOCKET_ERROR == dwStatus)
			goto cleanup;
		nNumBytes = SendSocketN(s,(BYTE*)&nServerFunction,sizeof(int));
		if (SOCKET_ERROR == nNumBytes)
			goto cleanup;
		nNumBytes = SendSocketN(s,(BYTE*)&KSPPacket,sizeof(MPIServeKillSingleProcessPacket_T));
		if (SOCKET_ERROR == nNumBytes)
			goto cleanup;
		nNumBytes = RecvSocketN(s,(BYTE*)&KSPRDPacket,sizeof(MPIServeKillSingleProcessReturnDataPacket_T));
		if (SOCKET_ERROR == nNumBytes)
			goto cleanup;
		if (KSPRDPacket.fStatus)
			printf("The process was killed.\n");
		else
			printf("The process was unable to be killed with error [%x]\n",KSPRDPacket.dwStatus);
	}
cleanup:
	dwStatus = WSAGetLastError();
	return dwStatus;
}