#include "windows.h"
#include "packets.h"
#include "processinfo.h"
#include "infoprint.h"
#include "mpirun.h"
#include "mpiservepacket.h"
#include "SocketReadAndWrite.h"
#include "mpiserve.h"
#include "crtdbg.h"

extern BOOL fDebug;
extern BOOL fWait;
extern char szMachineName[MAXPATHLEN];
extern char szExecutable[MAXPATHLEN];

DWORD RunSingleProc(int argc, char *argv[])
{
	DWORD dwStatus = ERROR_SUCCESS;
	int nNumBytes;
	int nServerFunction = MPI_SERVE_CREATE_SINGLE_PROCESS;
	SOCKET s;
	SOCKADDR_IN aAddress;
	struct hostent *pheEnt;
	WORD wPortNumber;
	MPIServeCreateSingleProcessPacket_T CSPPacket;
	MPIServeCreateSingleProcessReturnDataPacket_T CSPRDPacket;

	dwStatus = (DWORD)GetPortNumber(&wPortNumber);
	_ASSERTE(ERROR_SUCCESS == dwStatus);
	if (ERROR_SUCCESS == dwStatus)
	{
		strcpy(CSPPacket.szExecutableName,szExecutable);
		CSPPacket.fBlocking = fWait;
		pheEnt = gethostbyname(szMachineName);
		if (NULL == pheEnt)
			goto cleanup;
		aAddress.sin_port = htons(wPortNumber);
		aAddress.sin_family = AF_INET;
		memcpy(&aAddress.sin_addr,pheEnt->h_addr,pheEnt->h_length);
		s = socket(pheEnt->h_addrtype,SOCK_STREAM,0);
		if (INVALID_SOCKET == s)
			goto cleanup;
		dwStatus = (DWORD)connect(s,(PSOCKADDR)&aAddress,sizeof(SOCKADDR_IN));
		if (SOCKET_ERROR == dwStatus)
			goto cleanup;
		nNumBytes = SendSocketN(s,(BYTE*)&nServerFunction,sizeof(int));
		if (SOCKET_ERROR == nNumBytes)
			goto cleanup;
		nNumBytes = SendSocketN(s,(BYTE*)&CSPPacket,sizeof(MPIServeCreateSingleProcessPacket_T));
		if (SOCKET_ERROR == nNumBytes)
			goto cleanup;
		nNumBytes = RecvSocketN(s,(BYTE*)&CSPRDPacket,sizeof(MPIServeCreateSingleProcessReturnDataPacket_T));
		if (SOCKET_ERROR == nNumBytes)
			goto cleanup;
		printf("The process ID is (was) [%d]\n",CSPRDPacket.dwProcessID);
		printf("The process handle is (was) [%d]\n",CSPRDPacket.hProcess);
		printf("The status of the operation is (was) [%d]\n",CSPRDPacket.dwStatus);
		printf("The exit status of the process was (if you waited on it) [0x%x]\n",CSPRDPacket.dwProcessExitStatus);
	}

cleanup:
	dwStatus = (DWORD)WSAGetLastError();
	return dwStatus;
}