//  MODULE:   MPIServeKillSingleProcess.c
//
//  PURPOSE:	Function to Kill a single process
//
//  FUNCTIONS:
//
//		DWORD WINAPI MPIServeKillSingleProcess(LPVOID lpV)
//
//  COMMENTS:
//
//  AUTHOR: Shane Hebert
//


#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <tchar.h>
#include <winsock.h>
#include "service.h"
#include "processinfo.h"
#include "mpiserve.h"
#include "SocketReadAndWrite.h"
#include "MPIServePacket.h"

DWORD WINAPI MPIServeKillSingleProcess(LPVOID lpV)
{
	DWORD dwStatus = ERROR_SUCCESS;
	BOOL fStatus = FALSE;
	SOCKET sSocket = (SOCKET)lpV;
	MPIServeKillSingleProcessPacket_T KillPacket;
	MPIServeKillSingleProcessReturnDataPacket_T ReturnPacket;
	
	dwStatus = RecvSocketN(sSocket,
							(BYTE*)&KillPacket,
							sizeof(MPIServeKillSingleProcessPacket_T));
	if (SOCKET_ERROR != dwStatus)
		dwStatus = ERROR_SUCCESS;
	else
	{
		dwStatus = ReturnPacket.dwStatus = WSAGetLastError();
		ReturnPacket.fStatus = FALSE;
		goto reporterror;
	}

	ReturnPacket.fStatus = TerminateProcess(KillPacket.hProcess,KillPacket.dwExitCode);
	dwStatus = ReturnPacket.dwStatus = WSAGetLastError();

reporterror:
	SendSocketN(sSocket,
				(BYTE*)&ReturnPacket,
				sizeof(MPIServeKillSingleProcessReturnDataPacket_T));
	closesocket(sSocket);
	return dwStatus;
}