#include "windows.h"
#include "stdio.h"
#include "debuglog.h"

static BOOL fDebug = FALSE;
static BOOL fDebugInitialized = FALSE;
static FILE *debugLog = NULL;
static char szDebugFileName[2048];

DWORD SetDebugFileName(LPCSTR szFileName)
{
	DWORD dwStatus = ERROR_SUCCESS;

	if (szFileName)
	{
		if (!fDebugInitialized)
		{
			strcpy(szDebugFileName,szFileName);
			fDebugInitialized = TRUE;
		}
		else
			dwStatus = 1001;
	}
	else
		dwStatus = 1000;
	return dwStatus;
}

DWORD OpenDebugLog(LPCSTR szFlags)
{
	DWORD dwStatus = ERROR_SUCCESS;

	if (NULL != debugLog)
	{
		fflush(debugLog);
		fclose(debugLog);
		debugLog = NULL;
	}
	if (fDebugInitialized)
	{
		debugLog = fopen(szDebugFileName,szFlags);
		if (NULL != debugLog)
			dwStatus = ERROR_SUCCESS;
		else
			dwStatus = GetLastError();
	}
	else
		dwStatus = 1002;
	return dwStatus;
}

VOID CloseDebugLog(void)
{
	if (fDebugInitialized)
	{
		if (NULL != debugLog)
		{
			fflush(debugLog);
			fclose(debugLog);
			debugLog = NULL;
		}
	}
}

DWORD WriteDebugLog(LPCSTR szMsg)
{
	DWORD dwStatus = ERROR_SUCCESS;
	int nBytesWritten = 0;
	BOOL fOpenedByMe = FALSE;

	if (fDebugInitialized)
	{
		if (NULL == debugLog)
		{
			debugLog = fopen(szDebugFileName,"a+");
			if (NULL == debugLog)
			{
				dwStatus = GetLastError();
				goto cleanup;
			}
			fOpenedByMe = TRUE;
		}
		nBytesWritten = fprintf(debugLog,szMsg);
		if (0 < nBytesWritten)
		{
			nBytesWritten = fflush(debugLog);
			if (EOF == nBytesWritten)
			{
				dwStatus = GetLastError();
				goto cleanup;
			}
			dwStatus = ERROR_SUCCESS;
		}
		if (fOpenedByMe && (ERROR_SUCCESS == dwStatus))
		{
			fclose(debugLog);
			debugLog = NULL;
		}
	}
	else
		dwStatus = 1003;
cleanup:
	return dwStatus;
}
